import { world, system, BlockPermutation, EquipmentSlot, ItemStack } from "@minecraft/server";
import { uiManager, ActionFormData, ModalFormData, MessageFormData } from "@minecraft/server-ui";

let herobrineTorches = [];

if (world.getDynamicProperty("herobrine_activity") == null) {
    world.setDynamicProperty("herobrine_activity", true);
}
if (world.getDynamicProperty("herobrine_activity_rate") == null) {
    world.setDynamicProperty("herobrine_activity_rate", 10);
}
if (world.getDynamicProperty("herobrine_stalk_rate") == null) {
    world.setDynamicProperty("herobrine_stalk_rate", 10);
}
if (world.getDynamicProperty("herobrine_glimpse_rate") == null) {
    world.setDynamicProperty("herobrine_glimpse_rate", 10);
}
if (world.getDynamicProperty("herobrine_attack_rate") == null) {
    world.setDynamicProperty("herobrine_attack_rate", 10);
}
if (world.getDynamicProperty("herobrine_dont_turn_around_rate") == null) {
    world.setDynamicProperty("herobrine_dont_turn_around_rate", 10);
}
if (world.getDynamicProperty("herobrine_sign_rate") == null) {
    world.setDynamicProperty("herobrine_sign_rate", 10);
}
if (world.getDynamicProperty("herobrine_special_sign_rate") == null) {
    world.setDynamicProperty("herobrine_special_sign_rate", 10);
}
if (world.getDynamicProperty("herobrine_torch_deepslate_rate") == null) {
    world.setDynamicProperty("herobrine_torch_deepslate_rate", 10);
}
if (world.getDynamicProperty("herobrine_altar_rate") == null) {
    world.setDynamicProperty("herobrine_altar_rate", 10);
}
if (world.getDynamicProperty("herobrine_nightmare_rate") == null) {
    world.setDynamicProperty("herobrine_nightmare_rate", 10);
}
if (world.getDynamicProperty("herobrine_ambience_rate") == null) {
    world.setDynamicProperty("herobrine_ambience_rate", 10);
}
if (world.getDynamicProperty("herobrine_footsteps_rate") == null) {
    world.setDynamicProperty("herobrine_footsteps_rate", 10);
}
if (world.getDynamicProperty("herobrine_delete_torch_rate") == null) {
    world.setDynamicProperty("herobrine_delete_torch_rate", 10);
}
if (world.getDynamicProperty("herobrine_activity_timer") == null) {
    world.setDynamicProperty("herobrine_activity_timer", 600);
}
if (world.getDynamicProperty("herobrine_nightmare_day") == null) {
    world.setDynamicProperty("herobrine_nightmare_day", false);
}
if (world.getDynamicProperty("herobrine_nightmare_days_in_a_row") == null) {
    world.setDynamicProperty("herobrine_nightmare_days_in_a_row", 0);
}
if (world.getDynamicProperty("herobrine_delete_torch_timer") == null) {
    world.setDynamicProperty("herobrine_delete_torch_timer", 600);
}
if (world.getDynamicProperty("herobrine_possessed_mob_rate") == null) {
    world.setDynamicProperty("herobrine_possessed_mob_rate", 10);
}
if (world.getDynamicProperty("herobrine_fog_rate") == null) {
    world.setDynamicProperty("herobrine_fog_rate", 10);
}
if (world.getDynamicProperty("herobrine_fog_day") == null) {
    world.setDynamicProperty("herobrine_fog_day", false);
}
if (world.getDynamicProperty("herobrine_fog_days_in_a_row") == null) {
    world.setDynamicProperty("herobrine_fog_days_in_a_row", 0);
}
if (world.getDynamicProperty("calamity_enabled") == null) {
    world.setDynamicProperty("calamity_enabled", true);
}
if (world.getDynamicProperty("days_until_calamity") == null) {
    world.setDynamicProperty("days_until_calamity", 100);
}
if (world.getDynamicProperty("calamity_fog_active") == null) {
    world.setDynamicProperty("calamity_fog_active", false);
}
if (world.getDynamicProperty("is_day_of_calamity") == null) {
    world.setDynamicProperty("is_day_of_calamity", false);
}
if (world.getDynamicProperty("calamity_shake_timer") == null) {
    world.setDynamicProperty("calamity_shake_timer", 600);
}
if (world.getDynamicProperty("herobrine_defeated") == null) {
    world.setDynamicProperty("herobrine_defeated", false);
}

/*world.sendMessage("Herobrine Activity: " + world.getDynamicProperty("herobrine_activity"));
world.sendMessage("Herobrine Activity Rate: " + world.getDynamicProperty("herobrine_activity_rate"));
world.sendMessage("Herobrine Stalk Rate: " + world.getDynamicProperty("herobrine_stalk_rate"));
world.sendMessage("Herobrine Glimpse Rate: " + world.getDynamicProperty("herobrine_glimpse_rate"));
world.sendMessage("Herobrine Attack Rate: " + world.getDynamicProperty("herobrine_attack_rate"));
world.sendMessage("Herobrine Don't Turn Around Rate: " + world.getDynamicProperty("herobrine_dont_turn_around_rate"));
world.sendMessage("Herobrine Sign Rate: " + world.getDynamicProperty("herobrine_sign_rate"));
world.sendMessage("Herobrine Special Sign Rate: " + world.getDynamicProperty("herobrine_special_sign_rate"));
world.sendMessage("Herobrine Torch Deepslate Rate: " + world.getDynamicProperty("herobrine_torch_deepslate_rate"));
world.sendMessage("Herobrine Altar Rate: " + world.getDynamicProperty("herobrine_altar_rate"));
world.sendMessage("Herobrine Nightmare Rate: " + world.getDynamicProperty("herobrine_nightmare_rate"));
world.sendMessage("Herobrine Ambience Rate: " + world.getDynamicProperty("herobrine_ambience_rate"));
world.sendMessage("Herobrine Footsteps Rate: " + world.getDynamicProperty("herobrine_footsteps_rate"));
world.sendMessage("Herobrine Remove Random Torch Rate: " + world.getDynamicProperty("herobrine_delete_torch_rate"));*/

let herobrineActivity = world.getDynamicProperty("herobrine_activity");
let herobrineActivityRate = world.getDynamicProperty("herobrine_activity_rate");
let herobrineStalkRate = world.getDynamicProperty("herobrine_stalk_rate");
let herobrineGlimpseRate = world.getDynamicProperty("herobrine_glimpse_rate");
let herobrineAttackRate = world.getDynamicProperty("herobrine_attack_rate");
let herobrineDontTurnAroundRate = world.getDynamicProperty("herobrine_dont_turn_around_rate");
let herobrineSignRate = world.getDynamicProperty("herobrine_sign_rate");
let herobrineSpecialSignRate = world.getDynamicProperty("herobrine_special_sign_rate");
let herobrineTorchDeepslateRate = world.getDynamicProperty("herobrine_torch_deepslate_rate");
let herobrineAltarRate = world.getDynamicProperty("herobrine_altar_rate");
let herobrineNightmareRate = world.getDynamicProperty("herobrine_nightmare_rate");
let herobrineAmbienceRate = world.getDynamicProperty("herobrine_ambience_rate");
let herobrineFootstepsRate = world.getDynamicProperty("herobrine_footsteps_rate");
let herobrineDeleteTorchRate = world.getDynamicProperty("herobrine_delete_torch_rate");
let herobrinePossessedMobRate = world.getDynamicProperty("herobrine_possessed_mob_rate");
let herobrineFogRate = world.getDynamicProperty("herobrine_fog_rate");
let calamityEnabled = world.getDynamicProperty("calamity_enabled");
let daysUntilCalamity = world.getDynamicProperty("days_until_calamity");

function openHerobrineMenu(player) {
    const actionForm = new ActionFormData().title("Herobrine Menu");
    actionForm.body("\nChoose an option.");
    actionForm.button('Trigger Herobrine Event');
    actionForm.button('Adjust Herobrine Activity Rates');
    actionForm.button('Explanations of Addon Features');
    actionForm.button('Close');
    actionForm.show(player).then(response => {
        if (response.selection != undefined && response.selection == 0) {
            triggerHerobrineEvent(player);
        }
        else if (response.selection == 1) {
            adjustHerobrineRates(player);
        }
        else if (response.selection == 2) {
            explainAddonFeatures(player);
        }
    })
}

const eventsToChooseFrom = [
    { name: "Summon Herobrine", idNum: 0 },
    { name: "Reset Herobrine Anger", idNum: 1 },
    { name: "Herobrine Stalk", idNum: 2 },
    { name: "Herobrine Glimpse", idNum: 3 },
    { name: "Herobrine Attack", idNum: 4 },
    { name: "Herobrine Don't Turn Around", idNum: 5 },
    { name: "Herobrine Sign", idNum: 6 },
    { name: "Herobrine Special Sign", idNum: 7 },
    { name: "Herobrine Torch Deepslate", idNum: 8 },
    { name: "Herobrine Altar", idNum: 9 },
    { name: "Tag Target for Herobrine Nightmare", idNum: 10 },
    { name: "Toggle Herobrine Nightmare day", idNum: 11 },
    { name: "Herobrine Ambience", idNum: 12 },
    { name: "Herobrine Footsteps", idNum: 13 },
    { name: "Herobrine Boss", idNum: 14 },
    { name: "Herobrine Remove Random Torch", idNum: 15 },
    { name: "Edit Herobrine Anger", idNum: 16 },
    { name: "Set day as a Herobrine Fog day", idNum: 17 },
    { name: "Remove Herobrine Fog", idNum: 18 },
];

function triggerHerobrineEvent(player) {
    const players = world.getPlayers({excludeGameModes: ['spectator'],});
    const modalForm = new ModalFormData().title("Trigger Herobrine Event");
    modalForm.dropdown('Target', players.map((player) => player.name), player.getDynamicProperty("last_player_triggered_in_herobrine_menu"));
    modalForm.dropdown('Event', eventsToChooseFrom.map((event) => event.name), player.getDynamicProperty("last_event_triggered_in_herobrine_menu"));
    modalForm.show(player).then(response => {
        if (response.formValues != undefined) {
            player.setDynamicProperty("last_player_triggered_in_herobrine_menu", response.formValues[0]);
            player.setDynamicProperty("last_event_triggered_in_herobrine_menu", response.formValues[1]);
            processEventTrigger(player, response.formValues, players);
        }
        else {
            player.sendMessage("§7Closed menu without triggering an event.§r");
        }
    })
}

function processEventTrigger(player, changes, playerList) {
    const target = playerList[changes[0]];
    const event = eventsToChooseFrom[changes[1]];
    //world.sendMessage("Target: " + target.name);
    //world.sendMessage("Event: " + event.name);
    if (event.idNum == 0) {
        summonHerobrine(target, 0, 1, player);
    }
    else if (event.idNum == 1) {
        target.setDynamicProperty("herobrine_anger", 1);
        player.sendMessage("§7" + target.name + "'s Herobrine Anger successfully reset.§r");
    }
    else if (event.idNum == 2) {
        summonHerobrine(target, 0, 2, player);
    }
    else if (event.idNum == 3) {
        summonHerobrine(target, 0, 4, player);
    }
    else if (event.idNum == 4) {
        summonHerobrine(target, 0, 3, player);
    }
    else if (event.idNum == 5) {
        summonHerobrine(target, 0, 5, player);
    }
    else if (event.idNum == 6) {
        writeMessage(target, 1, player);
    }
    else if (event.idNum == 7) {
        writeMessage(target, 2, player);
    }
    else if (event.idNum == 8) {
        torchDeepslate(target, 1, player);
    }
    else if (event.idNum == 9) {
        spawnAltar(target, 1, player);
    }
    else if (event.idNum == 10) {
        target.addTag("zpig:summon_herobrine_nightmare_function");
        player.sendMessage("§7" + target.name + " was tagged for a Herobrine Nightmare.§r");
    }
    else if (event.idNum == 11) {
        processNightmareDay(1, player);
    }
    else if (event.idNum == 12) {
        playAmbience(target, 1, player);
    }
    else if (event.idNum == 13) {
        walkStone(target, 1, player);
    }
    else if (event.idNum == 14) {
        summonHerobrineBoss(target, target.location, 1, player);
    }
    else if (event.idNum == 15) {
        deleteTorch(1, player);
    }
    else if (event.idNum == 16) {
        const modalForm = new ModalFormData().title("Edit Herobrine Anger");
        modalForm.textField(target.name + '\'s Herobrine Anger', 'Input Herobrine Anger value', ("" + target.getDynamicProperty("herobrine_anger")));
        modalForm.show(player).then(searchResponse => {
            if (searchResponse.formValues != undefined) {
                processHerobrineAngerEdit(player, target, searchResponse.formValues);
            }
            else {
                player.sendMessage("§cYour changes were not saved.§r");
            }
        })
    }
    else if (event.idNum == 17) {
        processFogDay(1, player);
    }
    else if (event.idNum == 18) {
        target.runCommand("fog @s pop zpig:herobrine_fog");
        target.runCommand("fog @s pop zpig:heavy_calamity_fog");
        player.sendMessage("§7Herobrine Fog was removed from " + target.name + ".§r");
    }
    //player.sendMessage("§7Attempting to trigger event '" + event.name + "' on " + target.name + "§r");
}

function processHerobrineAngerEdit(player, target, changes) {
    if (target.getDynamicProperty("herobrine_anger") != changes[0]) {
        if (!isNaN(Number(changes[0]))) {
            let angerNum = Number(changes[0]);
            if (!Number.isInteger(angerNum)) {
                angerNum = Math.trunc(angerNum);
            }
            if (angerNum < 0) {
                angerNum = 0;
            }
            daysUntilCalamity = angerNum;
            target.setDynamicProperty("herobrine_anger", angerNum);
            player.sendMessage("§7" + target.name + "'s Herobrine Anger changed to " + target.getDynamicProperty("herobrine_anger") + ".§r");
        }
        else {
            player.sendMessage("§cHerobrine Anger must be a number.§r");
        }
    }
}

function adjustHerobrineRates(player) {
    const modalForm = new ModalFormData().title("Adjust Herobrine Activity Rates");
    modalForm.toggle("Herobrine Activity Enabled", world.getDynamicProperty("herobrine_activity"));
    modalForm.slider("Herobrine Activity Rate", 0, 20, 1, world.getDynamicProperty("herobrine_activity_rate"));
    modalForm.slider("Herobrine Stalk Rate", 0, 20, 1, world.getDynamicProperty("herobrine_stalk_rate"));
    modalForm.slider("Herobrine Glimpse Rate", 0, 20, 1, world.getDynamicProperty("herobrine_glimpse_rate"));
    modalForm.slider("Herobrine Attack Rate", 0, 20, 1, world.getDynamicProperty("herobrine_attack_rate"));
    modalForm.slider("Herobrine Don't Turn Around Rate", 0, 20, 1, world.getDynamicProperty("herobrine_dont_turn_around_rate"));
    modalForm.slider("Herobrine Sign Rate", 0, 20, 1, world.getDynamicProperty("herobrine_sign_rate"));
    modalForm.slider("Herobrine Special Sign Rate", 0, 20, 1, world.getDynamicProperty("herobrine_special_sign_rate"));
    modalForm.slider("Herobrine Torch Deepslate Rate", 0, 20, 1, world.getDynamicProperty("herobrine_torch_deepslate_rate"));
    modalForm.slider("Herobrine Altar Rate", 0, 20, 1, world.getDynamicProperty("herobrine_altar_rate"));
    modalForm.slider("Herobrine Nightmare Rate", 0, 20, 1, world.getDynamicProperty("herobrine_nightmare_rate"));
    modalForm.slider("Herobrine Ambience Rate", 0, 20, 1, world.getDynamicProperty("herobrine_ambience_rate"));
    modalForm.slider("Herobrine Footsteps Rate", 0, 20, 1, world.getDynamicProperty("herobrine_footsteps_rate"));
    modalForm.slider("Remove Random Torch Rate", 0, 20, 1, world.getDynamicProperty("herobrine_delete_torch_rate"));
    modalForm.slider("Possessed Mobs Spawn Rate", 0, 20, 1, world.getDynamicProperty("herobrine_possessed_mob_rate"));
    modalForm.slider("Herobrine Fog Rate", 0, 20, 1, world.getDynamicProperty("herobrine_fog_rate"));
    modalForm.toggle("Calamity Enabled", world.getDynamicProperty("calamity_enabled"));
    modalForm.textField('Days until Calamity', 'Input days until Calamity', ("" + world.getDynamicProperty("days_until_calamity")));
    modalForm.show(player).then(searchResponse => {
        if (searchResponse.formValues != undefined) {
            processRateChanges(player, searchResponse.formValues);
        }
        else {
            player.sendMessage("§cYour changes were not saved.§r");
        }
    })
}

function processRateChanges(player, changes) {
    if (herobrineActivity != undefined && herobrineActivity != changes[0]) {
        herobrineActivity = changes[0];
        world.setDynamicProperty("herobrine_activity", changes[0]);
        if (herobrineActivity == true) {
            player.sendMessage("§7Herobrine Activity has been enabled.§r");
        }
        else {
            processFogDay(2);
            player.sendMessage("§7Herobrine Activity has been disabled.§r");
        }
    }
    if (herobrineActivityRate != undefined && herobrineActivityRate != changes[1]) {
        herobrineActivityRate = changes[1];
        world.setDynamicProperty("herobrine_activity_rate", changes[1]);
        player.sendMessage("§7Herobrine Activity Rate changed to " + world.getDynamicProperty("herobrine_activity_rate") + ".§r");
    }
    if (herobrineStalkRate != undefined && herobrineStalkRate != changes[2]) {
        herobrineStalkRate = changes[2];
        world.setDynamicProperty("herobrine_stalk_rate", changes[2]);
        player.sendMessage("§7Herobrine Stalk Rate changed to " + world.getDynamicProperty("herobrine_stalk_rate") + ".§r");
    }
    if (herobrineGlimpseRate != undefined && herobrineGlimpseRate != changes[3]) {
        herobrineGlimpseRate = changes[3];
        world.setDynamicProperty("herobrine_glimpse_rate", changes[3]);
        player.sendMessage("§7Herobrine Glimpse Rate changed to " + world.getDynamicProperty("herobrine_glimpse_rate") + ".§r");
    }
    if (herobrineAttackRate != undefined && herobrineAttackRate != changes[4]) {
        herobrineAttackRate = changes[4];
        world.setDynamicProperty("herobrine_attack_rate", changes[4]);
        player.sendMessage("§7Herobrine Attack Rate changed to " + world.getDynamicProperty("herobrine_attack_rate") + ".§r");
    }
    if (herobrineDontTurnAroundRate != undefined && herobrineDontTurnAroundRate != changes[5]) {
        herobrineDontTurnAroundRate = changes[5];
        world.setDynamicProperty("herobrine_dont_turn_around_rate", changes[5]);
        player.sendMessage("§7Herobrine Don't Turn Around Rate changed to " + world.getDynamicProperty("herobrine_dont_turn_around_rate") + ".§r");
    }
    if (herobrineSignRate != undefined && herobrineSignRate != changes[6]) {
        herobrineSignRate = changes[6];
        world.setDynamicProperty("herobrine_sign_rate", changes[6]);
        player.sendMessage("§7Herobrine Sign Rate changed to " + world.getDynamicProperty("herobrine_sign_rate") + ".§r");
    }
    if (herobrineSpecialSignRate != undefined && herobrineSpecialSignRate != changes[7]) {
        herobrineSpecialSignRate = changes[7];
        world.setDynamicProperty("herobrine_special_sign_rate", changes[7]);
        player.sendMessage("§7Herobrine Special Sign Rate changed to " + world.getDynamicProperty("herobrine_special_sign_rate") + ".§r");
    }
    if (herobrineTorchDeepslateRate != undefined && herobrineTorchDeepslateRate != changes[8]) {
        herobrineTorchDeepslateRate = changes[8];
        world.setDynamicProperty("herobrine_torch_deepslate_rate", changes[8]);
        player.sendMessage("§7Herobrine Torch Deepslate Rate changed to " + world.getDynamicProperty("herobrine_torch_deepslate_rate") + ".§r");
    }
    if (herobrineAltarRate != undefined && herobrineAltarRate != changes[9]) {
        herobrineAltarRate = changes[9];
        world.setDynamicProperty("herobrine_altar_rate", changes[9]);
        player.sendMessage("§7Herobrine Altar Rate changed to " + world.getDynamicProperty("herobrine_altar_rate") + ".§r");
    }
    if (herobrineNightmareRate != undefined && herobrineNightmareRate != changes[10]) {
        herobrineNightmareRate = changes[10];
        world.setDynamicProperty("herobrine_nightmare_rate", changes[10]);
        player.sendMessage("§7Herobrine Nightmare Rate changed to " + world.getDynamicProperty("herobrine_nightmare_rate") + ".§r");
    }
    if (herobrineAmbienceRate != undefined && herobrineAmbienceRate != changes[11]) {
        herobrineAmbienceRate = changes[11];
        world.setDynamicProperty("herobrine_ambience_rate", changes[11]);
        player.sendMessage("§7Herobrine Ambience Rate changed to " + world.getDynamicProperty("herobrine_ambience_rate") + ".§r");
    }
    if (herobrineFootstepsRate != undefined && herobrineFootstepsRate != changes[12]) {
        herobrineFootstepsRate = changes[12];
        world.setDynamicProperty("herobrine_footsteps_rate", changes[12]);
        player.sendMessage("§7Herobrine Footsteps Rate changed to " + world.getDynamicProperty("herobrine_footsteps_rate") + ".§r");
    }
    if (herobrineDeleteTorchRate != undefined && herobrineDeleteTorchRate != changes[13]) {
        herobrineDeleteTorchRate = changes[13];
        world.setDynamicProperty("herobrine_delete_torch_rate", changes[13]);
        player.sendMessage("§7Remove Random Torch Rate changed to " + world.getDynamicProperty("herobrine_delete_torch_rate") + ".§r");
    }
    if (herobrinePossessedMobRate != undefined && herobrinePossessedMobRate != changes[14]) {
        herobrinePossessedMobRate = changes[14];
        world.setDynamicProperty("herobrine_possessed_mob_rate", changes[14]);
        player.sendMessage("§7Possessed Mobs Spawn Rate changed to " + world.getDynamicProperty("herobrine_possessed_mob_rate") + ".§r");
    }
    if (herobrineFogRate != undefined && herobrineFogRate != changes[15]) {
        herobrineFogRate = changes[15];
        world.setDynamicProperty("herobrine_fog_rate", changes[15]);
        player.sendMessage("§7Herobrine Fog Rate changed to " + world.getDynamicProperty("herobrine_fog_rate") + ".§r");
    }
    if (calamityEnabled != undefined && calamityEnabled != changes[16]) {
        calamityEnabled = changes[16];
        world.setDynamicProperty("calamity_enabled", changes[16]);
        if (calamityEnabled == true) {
            player.sendMessage("§7Calamity events have been enabled.§r");
            processCalamityDay(1);
        }
        else {
            player.sendMessage("§7Calamity events have been disabled.§r");
            processCalamityDay(3);
        }
    }
    if (daysUntilCalamity != undefined && daysUntilCalamity != changes[17]) {
        if (!isNaN(Number(changes[17]))) {
            let dayNum = Number(changes[17]);
            if (!Number.isInteger(dayNum)) {
                dayNum = Math.trunc(dayNum);
            }
            if (dayNum < 0) {
                dayNum = 0;
            }
            daysUntilCalamity = dayNum;
            world.setDynamicProperty("days_until_calamity", dayNum);
            if (calamityEnabled)
                processCalamityDay(1);
            player.sendMessage("§7Days until Calamity changed to " + world.getDynamicProperty("days_until_calamity") + ".§r");
        }
        else {
            player.sendMessage("§cDays until Calamity must be a number.§r");
        }
    }
}

for (const player of world.getPlayers()) {
    player.setDynamicProperty("last_player_triggered_in_herobrine_menu", 0);
    player.setDynamicProperty("last_event_triggered_in_herobrine_menu", 0);
}

function explainAddonFeatures(player) {
    const actionForm = new ActionFormData().title("Explanations of Addon Features");
    actionForm.body("\nChoose an option to view its explanation.");
    actionForm.button('Herobrine Activity');
    actionForm.button('Herobrine Anger');
    actionForm.button('Herobrine Glimpse, Stalk, Attack, and Don\'t Turn Around');
    actionForm.button('Herobrine Signs and Special Signs');
    actionForm.button('Herobrine Nightmares');
    actionForm.button('Herobrine Altars');
    actionForm.button('Herobrine Deepslate Torch');
    actionForm.button('Herobrine Ambience and Footsteps');
    actionForm.button('Herobrine Remove Random Torch');
    actionForm.button('Herobrine Boss');
    actionForm.button('Possessed Mobs');
    actionForm.button('Herobrine Structures');
    actionForm.button('Herobrine Fog');
    actionForm.button('Calamity Events');
    actionForm.button('Close');
    actionForm.show(player).then(response => {
        if (response.selection != undefined && response.selection != 14) {
            showExplanations(player, response.selection);
        }
    })
}

function showExplanations(player, selection) {
    let title;
    if (selection == 0)
        title = "Herobrine Activity";
    else if (selection == 1)
        title = "Herobrine Anger";
    else if (selection == 2)
        title = "Glimpse, Stalk, Attack, Don't Turn Around";
    else if (selection == 3)
        title = "Herobrine Signs and Special Signs";
    else if (selection == 4)
        title = "Herobrine Nightmares";
    else if (selection == 5)
        title = "Herobrine Altars";
    else if (selection == 6)
        title = "Herobrine Deepslate Torch";
    else if (selection == 7)
        title = "Herobrine Ambience and Footsteps";
    else if (selection == 8)
        title = "Herobrine Remove Random Torch";
    else if (selection == 9)
        title = "Herobrine Boss";
    else if (selection == 10)
        title = "Possessed Mobs";
    else if (selection == 11)
        title = "Herobrine Structures";
    else if (selection == 12)
        title = "Herobrine Fog";
    else
        title = "The Calamity";
    const actionForm = new ActionFormData().title(title);
    let body;
    if (selection == 0)
        body = "After the first day of being in your world, Herobrine Activity will begin. All of the features in this Addon fall under the umbrella of Herobrine Activity, with the exception of the Calamity. Changing the Activity rate will effect all other events. As with any rate, changing the rate to 0 will disable that activity, but you could also just use the toggle for Herobrine Activity.";
    else if (selection == 1)
        body = "When interacting with Herobrine, a player's Herobrine Anger may increase. The more Herobrine Anger you have, the more likely Herobrine is to target you. Your Herobrine Anger will naturally decrease over time. You can check or reset Herobrine Anger in the 'Trigger Herobrine Event' menu.";
    else if (selection == 2)
        body = "With these events, Herobrine will appear nearby in your world and watch you. For Glimpse mode, he will disappear as soon as he is on-screen. For Stalk mode, he will disappear when you point your crosshair near him. Attack mode is similar to Stalk mode, but instead of disappearing, Herobrine will instead lunge at the player and jumpscare them, doing a little damage in the process. For Don't Turn Around mode, Herobrine will spawn directly behind you and prevent you from moving. Once you turn around and look at Herobrine, he will disappear and you will be able to move again.";
    else if (selection == 3)
        body = "Herobrine will occasionally write messages on signs and leave them around your world. These signs may provide clues towards confronting Herobrine. These signs will eventually disappear on their own if left alone. There are 2 main types of signs, the normal Signs and the Special Signs. The normal Signs also have a chance of displaying rare text, written in gray instead of black. Special Signs have questions writtin in italics, and when interacted with, allow the user to answer Herobrine's questions, as well as get a response from him.";
    else if (selection == 4)
        body = "At the beginning of every day, there is a chance for that day to be marked as a 'Nightmare Day'. If any player attempts to sleep on a Nightmare Day, Herobrine will visit them in a Nightmare and prevent them from sleeping, making it so you cannot skip the night.";
    else if (selection == 5)
        body = "Herobrine Altars are small structures made of Gold Blocks and Netherrack with a Sign on top. The Sign holds key information about confronting Herobrine. Herobrine Altars will rarely spawn in your world.";
    else if (selection == 6)
        body = "When a player is deep underground at the Deepslate level, there is a chance for them to hear the sound of Herobrine mining Deepslate nearby and placing a Redstone Torch. If they decide to investigate and mine near the area where they heard the sound, they will find Herobrine's Redstone Torch. Attempting to trigger this event using the menu will not work unless the target player is near a significant amount of Deepslate.";
    else if (selection == 7)
        body = "Herobrine Ambience are spooky noises that will occasionally be played to players. Herobrine Footsteps is the sound of Herobrine walking nearby on Stone, and will only play naturally if the player is underground.";
    else if (selection == 8)
        body = "Every so often, Herobrine will remove a random torch that any player has placed. If a torch lasts in the world for long enough without being removed, it will become permanent and will not be removed by Herobrine.";
    else if (selection == 9)
        body = "You can confront Herobrine and fight him in this Addon. To summon Herobrine, you must first build an Altar as they appear in this Addon, and write a certain phrase on the sign at the top. Once Herobrine has been summoned, he will fly around and attack all nearby players. Herobrine does not have a healthbar, but instead shakes more and more violently the lower his health is. Herobrine has the ability to summon illusionary clones that will pursue the player and if they manage to land a hit, they will effect the player with blindness and disappear. Herobrine has the ability to fly through blocks in this phase. Once you get Herobrine to about 1/3 of his health, he will change phases and begin screaming and running on all fours in an attempt to brutally murder you. He retains the ability to summon illusionary clones, but can no longer fly and phase through blocks. That doesn't mean you're safe by hiding however, as Herobrine can and will find you wherever you may be. Upon defeating Herobrine, you will obtain a special item that is the key to stopping 'the Calamity'.";
    else if (selection == 10)
        body = "Whenever a certain mobs is spawned, there is a small chance it will be possessed by Herobrine, giving the mob glowing white eyes. The mobs will then be hostile towards the player and have increased health and damage. The following mobs can be possessed by Herobrine:\n-Chicken\n-Cow\n-Pig\n-Sheep\n-Skeleton\n-Zombie";
    else if (selection == 11)
        body = "Certain structures created by Herobrine can be found in the world. These can include pyramids, leafless trees, tunnels, and Redstone Torches.";
    else if (selection == 12)
        body = "At the beginning of every day, there is a chance for that day to be chosen as a 'Fog Day'. A heavy fog will appear in your world on fog days, reducing visibility.";
    else
        body = "The Calamity is a 'world ending' event that will occur " + daysUntilCalamity + " days from now, on day " + (world.getDay() + daysUntilCalamity) + ". The first step in stopping the Calamity is defeating Herobrine. The Calamity works seperatly from Herobrine Activity, so even if you disable Herobrine Activity the Calamity will still occur. Despite being called 'world ending' the Calamity will not actually grief your world, and can be easily reversed by disabling it. You can disable the Calamity or change when it occurs in the 'Adjust Herobrine Activity Rates' menu.";
    actionForm.body(body);
    actionForm.button('Back');
    actionForm.button('Close');
    actionForm.show(player).then(response => {
        if (response.selection != undefined && response.selection == 0) {
            explainAddonFeatures(player);
        }
    })
}

/*world.afterEvents.playerSpawn.subscribe((eventData) => {
    let { player, initialSpawn } = eventData;
    if (!initialSpawn) return;
    else {
        player.setDynamicProperty("herobrine_anger", 1);
        world.sendMessage(player.name + "'s Herobrine Anger: " + player.getDynamicProperty("herobrine_anger"));
    }
});*/

let herobrineListOverworld = world.getDimension("overworld").getEntities({type: 'zpig:herobrine',});
let herobrineListNether = world.getDimension("nether").getEntities({type: 'zpig:herobrine',});
let herobrineListEnd = world.getDimension("the_end").getEntities({type: 'zpig:herobrine',});
let herobrineList = herobrineListOverworld.concat(herobrineListNether, herobrineListEnd);

function updateHerobrineList() {
    let herobrineListOverworldNew = world.getDimension("overworld").getEntities({type: 'zpig:herobrine',});
    let herobrineListNetherNew = world.getDimension("nether").getEntities({type: 'zpig:herobrine',});
    let herobrineListEndNew = world.getDimension("the_end").getEntities({type: 'zpig:herobrine',});
    let herobrineListNew = herobrineListOverworldNew.concat(herobrineListNetherNew, herobrineListEndNew);
    herobrineList = herobrineListNew;
    //world.sendMessage("herobrineListNew.length: " + herobrineListNew.length);
    //world.sendMessage("herobrineList: " + herobrineList);
}

let whiteEyesListOverworld = world.getDimension("overworld").getEntities({type: 'zpig:white_eyes',});
let whiteEyesListNether = world.getDimension("nether").getEntities({type: 'zpig:white_eyes',});
let whiteEyesListEnd = world.getDimension("the_end").getEntities({type: 'zpig:white_eyes',});
let whiteEyesList = whiteEyesListOverworld.concat(whiteEyesListNether, whiteEyesListEnd);

let whiteEyesCalamityListOverworld = world.getDimension("overworld").getEntities({type: 'zpig:white_eyes_calamity',});
let whiteEyesCalamityListNether = world.getDimension("nether").getEntities({type: 'zpig:white_eyes_calamity',});
let whiteEyesCalamityListEnd = world.getDimension("the_end").getEntities({type: 'zpig:white_eyes_calamity',});
let whiteEyesCalamityList = whiteEyesCalamityListOverworld.concat(whiteEyesCalamityListNether, whiteEyesCalamityListEnd);

let calamitySpawnerListOverworld = world.getDimension("overworld").getEntities({type: 'zpig:calamity_spawner_entity',});
let calamitySpawnerListNether = world.getDimension("nether").getEntities({type: 'zpig:calamity_spawner_entity',});
let calamitySpawnerListEnd = world.getDimension("the_end").getEntities({type: 'zpig:calamity_spawner_entity',});
let calamitySpawnerList = calamitySpawnerListOverworld.concat(calamitySpawnerListNether, calamitySpawnerListEnd);

function updateWhiteEyesList() {
    let whiteEyesListOverworldNew = world.getDimension("overworld").getEntities({type: 'zpig:white_eyes',});
    let whiteEyesListNetherNew = world.getDimension("nether").getEntities({type: 'zpig:white_eyes',});
    let whiteEyesListEndNew = world.getDimension("the_end").getEntities({type: 'zpig:white_eyes',});
    let whiteEyesListNew = whiteEyesListOverworldNew.concat(whiteEyesListNetherNew, whiteEyesListEndNew);
    whiteEyesList = whiteEyesListNew;
    //world.sendMessage("whiteEyesListNew.length: " + whiteEyesListNew.length);
    //world.sendMessage("whiteEyesList: " + whiteEyesList);
    let whiteEyesCalamityListOverworldNew = world.getDimension("overworld").getEntities({type: 'zpig:white_eyes_calamity',});
    let whiteEyesCalamityListNetherNew = world.getDimension("nether").getEntities({type: 'zpig:white_eyes_calamity',});
    let whiteEyesCalamityListEndNew = world.getDimension("the_end").getEntities({type: 'zpig:white_eyes_calamity',});
    let whiteEyesCalamityListNew = whiteEyesCalamityListOverworldNew.concat(whiteEyesCalamityListNetherNew, whiteEyesCalamityListEndNew);
    whiteEyesCalamityList = whiteEyesCalamityListNew;

    let calamitySpawnerListOverworldNew = world.getDimension("overworld").getEntities({type: 'zpig:calamity_spawner_entity',});
    let calamitySpawnerListNetherNew = world.getDimension("nether").getEntities({type: 'zpig:calamity_spawner_entity',});
    let calamitySpawnerListEndNew = world.getDimension("the_end").getEntities({type: 'zpig:calamity_spawner_entity',});
    let calamitySpawnerListNew = calamitySpawnerListOverworldNew.concat(calamitySpawnerListNetherNew, calamitySpawnerListEndNew);
    calamitySpawnerList = calamitySpawnerListNew;
}

let herobrineSignSpotList = world.getDimension("overworld").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:herobrine_sign_spot"],});
let herobrineSpecialSignSpotList = world.getDimension("overworld").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:herobrine_special_sign_spot"],});
let playerSignSpotListOverworld = world.getDimension("overworld").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:player_sign_spot"],});
let playerSignSpotListNether = world.getDimension("nether").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:player_sign_spot"],});
let playerSignSpotListEnd = world.getDimension("the_end").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:player_sign_spot"],});
let playerSignSpotList = playerSignSpotListOverworld.concat(playerSignSpotListNether, playerSignSpotListEnd);
let playerTorchSpotListOverworld = world.getDimension("overworld").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:player_torch_spot"],});
let playerTorchSpotListNether = world.getDimension("nether").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:player_torch_spot"],});
let playerTorchSpotListEnd = world.getDimension("the_end").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:player_torch_spot"],});
let playerTorchSpotList = playerTorchSpotListOverworld.concat(playerTorchSpotListNether, playerTorchSpotListEnd);

function updateHerobrineSpotList() {
    let herobrineSignSpotListNew = world.getDimension("overworld").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:herobrine_sign_spot"],});
    herobrineSignSpotList = herobrineSignSpotListNew;

    let herobrineSpecialSignSpotListNew = world.getDimension("overworld").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:herobrine_special_sign_spot"],});
    herobrineSpecialSignSpotList = herobrineSpecialSignSpotListNew;

    let playerSignSpotListOverworldNew = world.getDimension("overworld").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:player_sign_spot"],});
    let playerSignSpotListNetherNew = world.getDimension("nether").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:player_sign_spot"],});
    let playerSignSpotListEndNew = world.getDimension("the_end").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:player_sign_spot"],});
    let playerSignSpotListNew = playerSignSpotListOverworldNew.concat(playerSignSpotListNetherNew, playerSignSpotListEndNew);
    playerSignSpotList = playerSignSpotListNew;

    let playerTorchSpotListOverworldNew = world.getDimension("overworld").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:player_torch_spot"],});
    let playerTorchSpotListNetherNew = world.getDimension("nether").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:player_torch_spot"],});
    let playerTorchSpotListEndNew = world.getDimension("the_end").getEntities({type: 'zpig:herobrine_spot_entity',tags: ["zpig:player_torch_spot"],});
    let playerTorchSpotListNew = playerTorchSpotListOverworldNew.concat(playerTorchSpotListNetherNew, playerTorchSpotListEndNew);
    playerTorchSpotList = playerTorchSpotListNew;
}

function facePlayer(player, entity) {
    let dx = player.location.x - entity.location.x;
    let dy = player.location.y - entity.location.y;
    let dz = player.location.z - entity.location.z;

    let yaw = Math.atan2(dz, dx) * (180 / Math.PI) - 90;
    let distance = Math.sqrt(dx * dx + dz * dz);
    let pitch = -Math.atan2(dy, distance) * (180 / Math.PI);

    entity.setRotation({ x: pitch, y: yaw });
}

function isEntityOnScreen(player, entity, screenValue, ignoreBlocks) {
    if (ignoreBlocks == undefined) {
        ignoreBlocks = false;
    }
    let direction = {
        x: entity.location.x - player.location.x,
        y: entity.location.y - player.location.y,
        z: entity.location.z - player.location.z
    };
    let length = Math.sqrt(direction.x ** 2 + direction.y ** 2 + direction.z ** 2);
    direction.x /= length;
    direction.y /= length;
    direction.z /= length;
    let viewDirection = player.getViewDirection();
    let dotProduct = direction.x * viewDirection.x + direction.y * viewDirection.y + direction.z * viewDirection.z;
    const value = screenValue;
    if (dotProduct > value) {
        let currentPos = {...player.location};
        let stepSize = 0.5;
        for (let i = 0; i < length / stepSize; i++) {
            currentPos.x += direction.x * stepSize;
            currentPos.y += direction.y * stepSize;
            currentPos.z += direction.z * stepSize;
            let blockLocation = {
                x: Math.floor(currentPos.x),
                y: Math.floor(currentPos.y),
                z: Math.floor(currentPos.z)
            };
            const block = player.dimension.getBlock({x: blockLocation.x, y: blockLocation.y + 1, z: blockLocation.z});

            /*world.sendMessage("block.location.x: " + block.location.x);
            world.sendMessage("block.location.y: " + block.location.y);
            world.sendMessage("block.location.z: " + block.location.z);
            world.sendMessage("block.typeId: " + block.typeId);*/

            if (!ignoreBlocks && block && (block.typeId != "minecraft:air") && block.isLiquidBlocking("Water")) {
                return false;
            }
        }
        return true;
    }
    else
        return false;
}

function pickWeightedHerobrineType() {
    const herobrineTypes = [
        { id: 0, weight: (45 * herobrineGlimpseRate) }, //Glimpse
        { id: 1, weight: (40 * herobrineStalkRate) }, //Stalk
        { id: 2, weight: (30 * herobrineAttackRate) }, //Attack
        { id: 3, weight: (35 * herobrineDontTurnAroundRate) }, //Don't Turn Around
    ];
    const total = herobrineTypes.reduce((sum, type) => sum + type.weight, 0);
    let point = Math.random() * total;
    for (const type of herobrineTypes) {
        point -= type.weight;
        if (point < 0) {
            return type.id;
        }
    }
    return herobrineTypes[herobrineTypes.length - 1];
}

function summonHerobrine(player, count, mode, summoner) {
    //world.sendMessage("herobrineList.length: " + herobrineList.length);
    if (player.dimension.id == "minecraft:overworld" && herobrineList.length < 1) {
        //world.sendMessage("player.dimension.id: " + player.dimension.id);
        const spawnRadius = 20;
        const minDistance = 10;
        let randomX, randomZ; 
            do {
                randomX = Math.floor(player.location.x + (Math.random() * 2 - 1) * spawnRadius);
                randomZ = Math.floor(player.location.z + (Math.random() * 2 - 1) * spawnRadius);
            } while (Math.sqrt(Math.pow(randomX - player.location.x, 2) + Math.pow(randomZ - player.location.z, 2)) < minDistance);
        const validY = getValidYCoordinate(player, randomX, randomZ);
        if (validY !== null) {
            if (mode == 0) {
                const herobrineType = pickWeightedHerobrineType();
                if (herobrineType == 0) {
                    const herobrine = player.dimension.spawnEntity("zpig:herobrine<zpig:mode_1_blink>", { x: randomX, y: validY, z: randomZ }); //Glimpse
                    if (summoner)
                        summoner.sendMessage("§7Herobrine was successfully summoned.§r");
                    facePlayer(player, herobrine);
                }
                else if (herobrineType == 1) {
                    const herobrine = player.dimension.spawnEntity("zpig:herobrine", { x: randomX, y: validY, z: randomZ }); //Stalk
                    if (summoner)
                        summoner.sendMessage("§7Herobrine was successfully summoned.§r");
                    facePlayer(player, herobrine);
                }
                else if (herobrineType == 2) {
                    const herobrine = player.dimension.spawnEntity("zpig:herobrine<zpig:mode_2>", { x: randomX, y: validY, z: randomZ }); //Attack
                    if (summoner)
                        summoner.sendMessage("§7Herobrine was successfully summoned.§r");
                    facePlayer(player, herobrine);
                }
                else if (herobrineType == 3) {
                    const playerPos = player.location;
                    const playerRot = player.getRotation();
                    const distanceBehind = 1.75;
                    const radians = (playerRot.y + 180) * (Math.PI / 180);
                    const spawnPos = {
                        x: playerPos.x - Math.sin(radians) * distanceBehind,
                        y: playerPos.y,
                        z: playerPos.z + Math.cos(radians) * distanceBehind
                    };
                    const herobrine = player.dimension.spawnEntity("zpig:herobrine<zpig:mode_1_dont_turn_around>", spawnPos); //Don't Turn Around
                    if (summoner)
                        summoner.sendMessage("§7Herobrine was successfully summoned.§r");
                    facePlayer(player, herobrine);
                }
            }
            else if (mode == 2) {
                const herobrine = player.dimension.spawnEntity("zpig:herobrine<zpig:stalk>", { x: randomX, y: validY, z: randomZ }); //Stalk
                if (summoner)
                    summoner.sendMessage("§7Herobrine was successfully summoned.§r");
                facePlayer(player, herobrine);
            }
            else if (mode == 3) {
                const herobrine = player.dimension.spawnEntity("zpig:herobrine<zpig:mode_2>", { x: randomX, y: validY, z: randomZ }); //Attack
                if (summoner)
                    summoner.sendMessage("§7Herobrine was successfully summoned.§r");
                facePlayer(player, herobrine);
            }
            else if (mode == 4) {
                const herobrine = player.dimension.spawnEntity("zpig:herobrine<zpig:mode_1_blink>", { x: randomX, y: validY, z: randomZ }); //Glimpse
                if (summoner)
                    summoner.sendMessage("§7Herobrine was successfully summoned.§r");
                facePlayer(player, herobrine);
            }
            else if (mode == 5) {
                const playerPos = player.location;
                const playerRot = player.getRotation();
                const distanceBehind = 1.75;
                const radians = (playerRot.y + 180) * (Math.PI / 180);
                const spawnPos = {
                    x: playerPos.x - Math.sin(radians) * distanceBehind,
                    y: playerPos.y,
                    z: playerPos.z + Math.cos(radians) * distanceBehind
                };
                const herobrine = player.dimension.spawnEntity("zpig:herobrine<zpig:mode_1_dont_turn_around>", spawnPos); //Don't Turn Around
                if (summoner)
                    summoner.sendMessage("§7Herobrine was successfully summoned.§r");
                facePlayer(player, herobrine);
            }
            //else
                //world.sendMessage("Herobrine Was Not Summoned.");
        }
        else {
            if (count < 11) {
                count++;
                //world.sendMessage("count: " + count);
                summonHerobrine(player, count);
            }
            if (summoner)
                summoner.sendMessage("§cThere was an error while attempting to summon Herobrine.§r");
        }
    }
    else if (summoner) {
        //world.sendMessage("herobrineList.length: " + herobrineList.length);
        if (player.dimension.id != "minecraft:overworld") {
            summoner.sendMessage("§cTarget must be in the Overworld.§r");
        }
        else if (herobrineList.length > 0) {
            summoner.sendMessage("§cHerobrine is already in the world.§r");
        }
    }
}

function pickWeightedSignType() {
    const signTypes = [
        { id: 0, weight: (75 * herobrineSignRate) }, //Normal
        { id: 1, weight: (25 * herobrineSpecialSignRate) }, //Special
    ];
    const total = signTypes.reduce((sum, type) => sum + type.weight, 0);
    let point = Math.random() * total;
    for (const type of signTypes) {
        point -= type.weight;
        if (point < 0) {
            return type.id;
        }
    }
    return signTypes[signTypes.length - 1];
}

function writeMessage(player, mode, summoner) {
    if (player.dimension.id == "minecraft:overworld") {
        //world.sendMessage("player.dimension.id: " + player.dimension.id);
        const spawnRadius = 15;
        const minDistance = 10;
        let randomX, randomZ;
            do {
                randomX = Math.floor(player.location.x + (Math.random() * 2 - 1) * spawnRadius);
                randomZ = Math.floor(player.location.z + (Math.random() * 2 - 1) * spawnRadius);
            } while (Math.sqrt(Math.pow(randomX - player.location.x, 2) + Math.pow(randomZ - player.location.z, 2)) < minDistance);
        
        const validY = getValidYCoordinateForSign(player, randomX, randomZ);
        if (validY !== null) {
            const block = world.getDimension("overworld").getBlock({ x: randomX, y: validY, z: randomZ });
            block.setPermutation(BlockPermutation.resolve("minecraft:standing_sign"));
            const sign = block.getComponent("minecraft:sign");
            sign.setWaxed(true);
            const type = pickWeightedSignType();
            if ((type == 0 && mode == 0) || mode == 1) {
                const spot = block.dimension.spawnEntity("zpig:herobrine_spot_entity<zpig:sign>", block.location);
                const rareMessages = [
                    "§8I am sorry, " + player.name + "...",
                    "§8She is watching you, " + player.name + ".",
                    "§8This is not my fault.",
                    "§8She is in control of me.",
                    "§8I need your help, " + player.name + "."
                ];
                if (calamityEnabled) {
                    if ((world.getDay() + daysUntilCalamity) == 1) {
                        rareMessages.push("§8Everything will end on the 1st day if we don't stop her.");
                    }
                    else if ((world.getDay() + daysUntilCalamity) == 2) {
                        rareMessages.push("§8Everything will end on the 2nd day if we don't stop her.");
                    }
                    else if ((world.getDay() + daysUntilCalamity) == 3) {
                        rareMessages.push("§8Everything will end on the 3rd day if we don't stop her.");
                    }
                    else {
                        rareMessages.push("§8Everything will end on the " + (world.getDay() + daysUntilCalamity) + "th day if we don't stop her.");
                    }
                }
                const commonMessages = [
                    "Leave while you still can.",
                    "You must bulid an altar...",
                    "Your time is running out, " + player.name + ".",
                    "You cannot stop it alone, " + player.name + ".",
                    "You will not be able to save yourself, " + player.name + ".",
                    "The end approaches.",
                    "Find the altars.",
                    "Your world is in danger.",
                    "The altars hold the key to survival.",
                    "This cannot last forever.",
                    "You must act, " + player.name + ".",
                    "You will not be able to escape it.",
                    "Follow the signs, build an altar.",
                ];
                if (calamityEnabled) {
                    commonMessages.push("The calamity is coming.");
                    if ((world.getDay() + daysUntilCalamity) == 1) {
                        commonMessages.push("This world will be destroyed on the 1st day.");
                    }
                    else if ((world.getDay() + daysUntilCalamity) == 2) {
                        commonMessages.push("This world will be destroyed on the 2nd day.");
                    }
                    else if ((world.getDay() + daysUntilCalamity) == 3) {
                        commonMessages.push("This world will be destroyed on the 3rd day.");
                    }
                    else {
                        commonMessages.push("This world will be destroyed on the " + (world.getDay() + daysUntilCalamity) + "th day.");
                    }
                    if (daysUntilCalamity == 1) {
                        commonMessages.push("You have " + daysUntilCalamity + " day remaining.");
                    }
                    else {
                        commonMessages.push("You have " + daysUntilCalamity + " days remaining.");
                    }
                }
                const rareProbability = 0.2;
                if (Math.random() < rareProbability) {
                    sign.setText(rareMessages[Math.floor(Math.random() * rareMessages.length)]);
                } else {
                    sign.setText(commonMessages[Math.floor(Math.random() * commonMessages.length)]);
                }
                if (summoner)
                    summoner.sendMessage("§7Herobrine's Sign successfully placed.§r");
            }
            else if ((type == 1 && mode == 0) || mode == 2) {
                const spot = block.dimension.spawnEntity("zpig:herobrine_spot_entity<zpig:special_sign>", block.location);
                const messages = [
                    { text: "§oDo you believe the stories you have been told?", index: 0 },
                    { text: "§oCan you be trusted?", index: 1 },
                    { text: "§o...\nIs that you, brother?", index: 2 },
                    { text: "§oHave you found the altars?", index: 3 },
                ];
                if (calamityEnabled) {
                    messages.push({ text: "§oWill you stop the calamity?", index: 4 });
                }
                const randomIndex = Math.floor(Math.random() * messages.length);
                sign.setText(messages[randomIndex].text);
                spot.setProperty("zpig:special_sign_type", messages[randomIndex].index);
                if (summoner)
                    summoner.sendMessage("§7Herobrine's Special Sign successfully placed.§r");
            }
        }
        else if (summoner)
            summoner.sendMessage("§cThere was an error while attempting to place Herobrine's Sign.§r");
    }
    else if (summoner)
        summoner.sendMessage("§cTarget must be in the Overworld.§r");
}

function torchDeepslate(player, mode, summoner) {
    if (player.dimension.id == "minecraft:overworld") {
        //world.sendMessage("player.dimension.id: " + player.dimension.id);
        const spawnRadius = 6;
        const minDistance = 4;
        let randomX, randomZ;
            do {
                randomX = Math.floor(player.location.x + (Math.random() * 2 - 1) * spawnRadius);
                randomZ = Math.floor(player.location.z + (Math.random() * 2 - 1) * spawnRadius);
            } while (Math.sqrt(Math.pow(randomX - player.location.x, 2) + Math.pow(randomZ - player.location.z, 2)) < minDistance);
        
        const validY = getValidYCoordinateTorchDeepslate(player, randomX, randomZ);
        if (validY !== null) {
            const block = player.dimension.getBlock({ x: randomX, y: validY, z: randomZ });
            block.setPermutation(BlockPermutation.resolve("minecraft:redstone_torch"));
            player.dimension.playSound("mob.herobrine.place_torch_deepslate", block.location);
            herobrineTorches.push(block);
            if (summoner)
                summoner.sendMessage("§7Herobrine's Torch successfully placed.§r");
        }
        else if (summoner)
            summoner.sendMessage("§cThere was an error while attempting to place Herobrine's Torch.§r");
    }
    else if (summoner)
        summoner.sendMessage("§cTarget must be in the Overworld.§r");
}

function walkStone(player, mode, summoner) {
    if (player.dimension.id == "minecraft:overworld") {
        //world.sendMessage("player.dimension.id: " + player.dimension.id);
        const spawnRadius = 5;
        const minDistance = 3;
        let randomX, randomY, randomZ;
        do {
            randomX = Math.floor(player.location.x + (Math.random() * 2 - 1) * spawnRadius);
            randomY = Math.floor(player.location.y + (Math.random() * 2 - 1) * spawnRadius);
            randomZ = Math.floor(player.location.z + (Math.random() * 2 - 1) * spawnRadius);
        } while (Math.sqrt(Math.pow(randomX - player.location.x, 2) + Math.pow(randomY - player.location.y, 2) + Math.pow(randomZ - player.location.z, 2)) < minDistance);
        player.dimension.playSound("mob.herobrine.walk_stone", { x: randomX, y: randomY, z: randomZ });
        if (summoner)
            summoner.sendMessage("§7Herobrine's Footsteps successfully played to " + player.name + ".§r");
    }
    else if (summoner)
        summoner.sendMessage("§cTarget must be in the Overworld.§r");
}

function playAmbience(player, mode, summoner) {
    if (player.dimension.id == "minecraft:overworld") {
        //world.sendMessage("player.dimension.id: " + player.dimension.id);
        player.playSound("mob.herobrine.ambience");
        //player.dimension.playSound("mob.herobrine.ambience", player.location);
        if (summoner)
            summoner.sendMessage("§7Herobrine's Ambience successfully played to " + player.name + ".§r");
    }
    else if (summoner)
        summoner.sendMessage("§cTarget must be in the Overworld.§r");
}

function spawnAltar(player, mode, summoner) {
    if (player.dimension.id == "minecraft:overworld") {
        //world.sendMessage("player.dimension.id: " + player.dimension.id);
        const spawnRadius = 64;
        const minDistance = 32;
        let randomX, randomZ;
        let validY;
        let countX = 0;
        let countZ = 0;
        let countY = 0;
        let closestDistance = Infinity;
        //randomX = Math.floor(player.location.x + (Math.random() * 2 - 1) * spawnRadius);
        //randomZ = Math.floor(player.location.z + (Math.random() * 2 - 1) * spawnRadius);
        do {
            randomX = Math.floor(player.location.x + (Math.random() * 2 - 1) * spawnRadius);
            closestDistance = Infinity;
            for (const aPlayer of world.getPlayers({excludeGameModes: ['spectator'],})) {
                const playerPosition = aPlayer.location;
                const distance = Math.sqrt(
                    Math.pow(playerPosition.x - randomX, 2)
                );
                if (distance < closestDistance) {
                    closestDistance = distance;
                }
            }
            countX++;
        } while ((Math.sqrt(Math.pow(randomX - player.location.x, 2)) || (closestDistance >= minDistance)) && countX <= 30);
        do {
            randomZ = Math.floor(player.location.z + (Math.random() * 2 - 1) * spawnRadius);
            closestDistance = Infinity;
            for (const aPlayer of world.getPlayers({excludeGameModes: ['spectator'],})) {
                const playerPosition = aPlayer.location;
                const distance = Math.sqrt(
                    Math.pow(playerPosition.z - randomZ, 2)
                );
                if (distance < closestDistance) {
                    closestDistance = distance;
                }
            }
            countZ++
        } while ((Math.sqrt(Math.pow(randomZ - player.location.z, 2)) || (closestDistance >= minDistance)) && countZ <= 30);
        do {
            validY = getValidYCoordinateForAltar(player, randomX, randomZ);
            countY++
        } while (validY == null && countY <= 30);
        if (validY !== null) {
            /*world.sendMessage("randomX: " + randomX);
            world.sendMessage("validY: " + validY);
            world.sendMessage("randomZ: " + randomZ);*/
            const randNum = Math.floor(Math.random() * 5);
            if (randNum == 0) {
                world.structureManager.place("zpig.altar_1", player.dimension, { x: randomX, y: validY, z: randomZ });
                //world.sendMessage("Herobrine's Altar 1 Placed.");
            }
            else if (randNum == 1) {
                world.structureManager.place("zpig.altar_2", player.dimension, { x: randomX, y: validY, z: randomZ });
                //world.sendMessage("Herobrine's Altar 2 Placed.");
            }
            else if (randNum == 2) {
                world.structureManager.place("zpig.altar_3", player.dimension, { x: randomX, y: validY, z: randomZ });
                //world.sendMessage("Herobrine's Altar 3 Placed.");
            }
            else {
                world.structureManager.place("zpig.altar_4", player.dimension, { x: randomX, y: validY, z: randomZ });
                //world.sendMessage("Herobrine's Altar 4 Placed.");
            }
            if (summoner)
                summoner.sendMessage("§7Herobrine's Altar successfully placed.§r");
        }
        else if (summoner)
            summoner.sendMessage("§cThere was an error while attempting to place Herobrine's Altar.§r");
    }
    else if (summoner)
        summoner.sendMessage("§cTarget must be in the Overworld.§r");
}

function summonHerobrineBoss(player, spawnLocation, mode, summoner) {
    if (mode == 0) {
        player.dimension.spawnEntity("minecraft:lightning_bolt", spawnLocation);
        const herobrine = player.dimension.spawnEntity("zpig:herobrine<zpig:mode_boss>", { x: spawnLocation.x, y: spawnLocation.y - 2, z: spawnLocation.z });
        facePlayer(player, herobrine);
        //world.sendMessage("Herobrine Boss Function On " + player.name + ".");
    }
    else {
        player.dimension.spawnEntity("minecraft:lightning_bolt", { x: spawnLocation.x, y: spawnLocation.y + 2, z: spawnLocation.z });
        const herobrine = player.dimension.spawnEntity("zpig:herobrine<zpig:mode_boss>", spawnLocation);
        facePlayer(player, herobrine);
        if (summoner)
            summoner.sendMessage("§7Herobrine boss successfully summoned.§r");
    }
}

let timerHerobrine = 0;
let timerWhiteEyes = 0;

world.afterEvents.entityHitEntity.subscribe(function(data) {
    if ((data.damagingEntity.typeId == "zpig:herobrine") && ((data.damagingEntity.getComponent("skin_id").value == 4) || (data.damagingEntity.getComponent("skin_id").value == 41))) {
        timerHerobrine = 0;
    }
    else if (data.damagingEntity.typeId == "zpig:white_eyes") {
        timerWhiteEyes = 0;
    }
    else if (data.damagingEntity.typeId == "zpig:herobrine_illusion") {
        data.damagingEntity.runCommand("event entity @s zpig:leave_short");
    }
    else if (data.hitEntity != undefined && (data.damagingEntity.typeId == "minecraft:player" && (data.damagingEntity.getGameMode() == "survival" || data.damagingEntity.getGameMode() == "adventure")) && (data.hitEntity.typeId == "zpig:herobrine" && data.hitEntity.getComponent("skin_id").value == 41)) {
        data.hitEntity.teleport({ x: data.hitEntity.location.x + (Math.random() * 4 - 2), y: data.hitEntity.location.y + (Math.random() * 4 - 2), z: data.hitEntity.location.z + (Math.random() * 4 - 2) });
    }
    else if (data.hitEntity != undefined && (data.damagingEntity.typeId == "minecraft:player" && (data.damagingEntity.getGameMode() == "survival" || data.damagingEntity.getGameMode() == "adventure")) && (data.hitEntity.typeId == "zpig:white_eyes" && data.hitEntity.hasComponent("is_ignited"))) {
        const player = data.damagingEntity;
        const whiteEyes = data.hitEntity;
        player.setDynamicProperty("white_eyes_counter_timer", 1);
        player.runCommand("inputpermission set @s movement disabled");
        const playerPos = player.location;
        const playerRot = player.getRotation();
        const distanceInFront = 4.0;
        const radians = (playerRot.y) * (Math.PI / 180);
        const teleportPos = {
            x: playerPos.x - Math.sin(radians) * distanceInFront,
            y: playerPos.y,
            z: playerPos.z + Math.cos(radians) * distanceInFront
        };
        whiteEyes.teleport(teleportPos);
        facePlayer(player, whiteEyes);
    }
})

system.runInterval(() => {
    timerHerobrine++;
    timerWhiteEyes++;
    //world.sendMessage("timerHerobrine: " + timerHerobrine);
    if (timerHerobrine == 10) {
        for (const herobrine of herobrineList) {
            if (herobrine && herobrine.getComponent("skin_id").value == 4) {
                const targetList = herobrine.dimension.getPlayers({
                    location: herobrine.location,
                    closest: 1,
                    excludeGameModes: ['creative', 'spectator'],
                });
                if (targetList.length > 0) {
                    const coord = getValidCoordinate(targetList[0], 3, 2, 2);
                    if (coord != null) {
                        herobrine.runCommand("event entity @s zpig:boss_go_in_ground");
                        herobrine.teleport(coord);
                    }
                    else {
                        herobrine.runCommand("event entity @s zpig:boss_go_in_ground");
                        herobrine.teleport(targetList[0].location);
                    }
                }
            }
            else if (herobrine.getComponent("skin_id").value == 41) {
                const targetList = herobrine.dimension.getPlayers({
                    location: herobrine.location,
                    closest: 1,
                    excludeGameModes: ['creative', 'spectator'],
                });
                if (targetList.length > 0) {
                    const coord = getValidCoordinate(targetList[0], 3, 2, 3, true);
                    if (coord != null) {
                        herobrine.teleport(coord);
                    }
                    else {
                        herobrine.teleport(targetList[0].location);
                    }
                }
            }
        }
    }
    if (timerHerobrine >= 20) {
        for (const herobrine of herobrineList) {
            if (herobrine && herobrine.getComponent("skin_id").value == 4) {
                const targetList = herobrine.dimension.getPlayers({
                    location: herobrine.location,
                    closest: 1,
                    excludeGameModes: ['creative', 'spectator'],
                });
                if (targetList.length > 0) {
                    herobrine.runCommand("event entity @s zpig:boss_go_in_ground");
                    herobrine.teleport(targetList[0].location);
                }
            }
            else if (herobrine.getComponent("skin_id").value == 41) {
                const targetList = herobrine.dimension.getPlayers({
                    location: herobrine.location,
                    closest: 1,
                    excludeGameModes: ['creative', 'spectator'],
                });
                if (targetList.length > 0) {
                    herobrine.teleport(targetList[0].location);
                }
            }
        }
        timerHerobrine = 0;
    }
    if (timerWhiteEyes == 12) {
        for (const whiteEyes of whiteEyesList) {
            if (whiteEyes.getComponent("skin_id").value == 2) {
                const targetList = whiteEyes.dimension.getPlayers({
                    location: whiteEyes.location,
                    closest: 1,
                    excludeGameModes: ['creative', 'spectator'],
                });
                const players = whiteEyes.dimension.getEntities({
                    location: whiteEyes.location,
                    maxDistance: 32,
                    type: 'minecraft:player',
                    excludeGameModes: ['spectator'],
                });
                players.push(targetList[0]);
                if (targetList.length > 0) {
                    const coord = getValidCoordinate(targetList[0], 6, 3, 2);
                    const playersAtLocation = whiteEyes.dimension.getEntities({
                        location: coord,
                        maxDistance: 28,
                        type: 'minecraft:player',
                        excludeGameModes: ['spectator'],
                    });
                    players.concat(playersAtLocation);
                    if (coord != null) {
                        for (const player of players) {
                            player.runCommand("title @s title zpig.display_calamity_eyes");
                            player.playSound("mob.white_eyes.teleport", { pitch: (Math.random() * (1.2 - 0.8) + 0.8) });
                        }
                        system.runTimeout(() => {
                            whiteEyes.teleport(coord);
                        }, 1);
                        system.runTimeout(() => {
                            for (const player of world.getPlayers()) {
                                player.runCommand("title @s title zpig.remove_calamity_eyes");
                            }
                        }, 10);
                    }
                    else {
                        whiteEyes.teleport(targetList[0].location);
                    }
                }
            }
        }
    }
    if (timerWhiteEyes >= 24) {
        for (const whiteEyes of whiteEyesList) {
            if (whiteEyes.getComponent("skin_id").value == 2) {
                const targetList = whiteEyes.dimension.getPlayers({
                    location: whiteEyes.location,
                    closest: 1,
                    excludeGameModes: ['creative', 'spectator'],
                });
                const players = whiteEyes.dimension.getEntities({
                    location: whiteEyes.location,
                    maxDistance: 32,
                    type: 'minecraft:player',
                    excludeGameModes: ['spectator'],
                });
                players.push(targetList[0]);
                if (targetList.length > 0) {
                    const playersAtLocation = whiteEyes.dimension.getEntities({
                        location: targetList[0].location,
                        maxDistance: 28,
                        type: 'minecraft:player',
                        excludeGameModes: ['spectator'],
                    });
                    players.concat(playersAtLocation);
                    for (const player of players) {
                        player.runCommand("title @s title zpig.display_calamity_eyes");
                        player.playSound("mob.white_eyes.teleport", { pitch: (Math.random() * (1.2 - 0.8) + 0.8) });
                    }
                    system.runTimeout(() => {
                        whiteEyes.teleport(targetList[0].location);
                    }, 1);
                    system.runTimeout(() => {
                        for (const player of world.getPlayers()) {
                            player.runCommand("title @s title zpig.remove_calamity_eyes");
                        }
                    }, 10);
                }
            }
        }
        timerWhiteEyes = 0;
    }
}, 20)

function getValidYCoordinateTorchDeepslate(player, xLocation, zLocation) {
    const range = 2;
    let adjustedYOffset = 0;
    for (let yOffset = 0; yOffset <= range * 2; yOffset++) {
        if (yOffset == 1 && adjustedYOffset >= 0) {
            adjustedYOffset = -1;
        } else {
            if (adjustedYOffset <= 0) {
                adjustedYOffset = Math.abs(adjustedYOffset);
            } else {
                adjustedYOffset = -adjustedYOffset - 1;
            }
        }
        //world.sendMessage("adjustedYOffset: " + adjustedYOffset);
        const y = Math.floor(player.location.y) + adjustedYOffset;
        if (y >= -64 && y <= 320) {
            const blockLocation = { x: xLocation, y: y, z: zLocation };
            const blockAtPosition = player.dimension.getBlock(blockLocation);
            const blockAbove = player.dimension.getBlock({ x: xLocation, y: y + 1, z: zLocation });
            const blockBelow = player.dimension.getBlock({ x: xLocation, y: y - 1, z: zLocation });
            const blockEast = player.dimension.getBlock({ x: xLocation + 1, y: y, z: zLocation });
            const blockWest = player.dimension.getBlock({ x: xLocation - 1, y: y, z: zLocation });
            const blockNorth = player.dimension.getBlock({ x: xLocation, y: y, z: zLocation - 1 });
            const blockSouth = player.dimension.getBlock({ x: xLocation, y: y, z: zLocation + 1 });
            if ((!blockAbove.isAir && !blockAbove.isLiquid) && (!blockBelow.isAir && !blockBelow.isLiquid) && (!blockEast.isAir && !blockEast.isLiquid) && (!blockWest.isAir && !blockWest.isLiquid) && (!blockNorth.isAir && !blockNorth.isLiquid) && (!blockSouth.isAir && !blockSouth.isLiquid) && (blockAtPosition.typeId == "minecraft:deepslate")) {
                return y;
            }
        }
    }
    return null;
}

function getValidYCoordinateForSign(player, xLocation, zLocation) {
    const range = 12;
    let adjustedYOffset = 0;
    for (let yOffset = 0; yOffset <= range * 2; yOffset++) {
        if (yOffset == 1 && adjustedYOffset >= 0) {
            adjustedYOffset = -1;
        } else {
            if (adjustedYOffset <= 0) {
                adjustedYOffset = Math.abs(adjustedYOffset);
            } else {
                adjustedYOffset = -adjustedYOffset - 1;
            }
        }
        //world.sendMessage("adjustedYOffset: " + adjustedYOffset);
        const y = Math.floor(player.location.y) + adjustedYOffset;
        if (y >= -64 && y <= 320) {
            const blockLocation = { x: xLocation, y: y, z: zLocation };
            const blockAtPosition = player.dimension.getBlock(blockLocation);
            const blockAbove = player.dimension.getBlock({ x: xLocation, y: y + 1, z: zLocation });
            if (!blockAtPosition.isAir && !blockAtPosition.isLiquid && blockAtPosition.isLiquidBlocking("Water") && !blockAbove.isLiquidBlocking("Water")) {
                return y + 1;
            }
        }
    }
    return null;
}

function getValidYCoordinateForAltar(player, xLocation, zLocation) {
    const range = 32;
    let adjustedYOffset = 0;
    for (let yOffset = 0; yOffset <= range * 2; yOffset++) {
        if (yOffset == 1 && adjustedYOffset >= 0) {
            adjustedYOffset = -1;
        } else {
            if (adjustedYOffset <= 0) {
                adjustedYOffset = Math.abs(adjustedYOffset);
            } else {
                adjustedYOffset = -adjustedYOffset - 1;
            }
        }
        //world.sendMessage("adjustedYOffset: " + adjustedYOffset);
        const y = Math.floor(player.location.y) + adjustedYOffset;
        if (y >= -64 && y <= 320) {
            const blockLocation = { x: xLocation, y: y, z: zLocation };
            const blocksBelow = [
                /*const blockBelow1 = player.dimension.getBlock({ x: xLocation, y: y - 1, z: zLocation });
                const blockEast1Below1 = player.dimension.getBlock({ x: xLocation + 1, y: y - 1, z: zLocation });
                const blockEast2Below1 = player.dimension.getBlock({ x: xLocation + 2, y: y - 1, z: zLocation });
                const blockSouth1Below1 = player.dimension.getBlock({ x: xLocation, y: y - 1, z: zLocation + 1 });
                const blockSouth2Below1 = player.dimension.getBlock({ x: xLocation, y: y - 1, z: zLocation + 2 });
                const blockEast1South1Below1 = player.dimension.getBlock({ x: xLocation + 1, y: y - 1, z: zLocation + 1 });
                const blockEast2South1Below1 = player.dimension.getBlock({ x: xLocation + 2, y: y - 1, z: zLocation + 1 });
                const blockEast1South2Below1 = player.dimension.getBlock({ x: xLocation + 1, y: y - 1, z: zLocation + 2 });
                const blockEast2South2Below1 = player.dimension.getBlock({ x: xLocation + 2, y: y - 1, z: zLocation + 2 });*/
                player.dimension.getBlock({ x: xLocation, y: y - 1, z: zLocation }),
                player.dimension.getBlock({ x: xLocation + 1, y: y - 1, z: zLocation }),
                player.dimension.getBlock({ x: xLocation + 2, y: y - 1, z: zLocation }),
                player.dimension.getBlock({ x: xLocation, y: y - 1, z: zLocation + 1 }),
                player.dimension.getBlock({ x: xLocation, y: y - 1, z: zLocation + 2 }),
                player.dimension.getBlock({ x: xLocation + 1, y: y - 1, z: zLocation + 1 }),
                player.dimension.getBlock({ x: xLocation + 2, y: y - 1, z: zLocation + 1 }),
                player.dimension.getBlock({ x: xLocation + 1, y: y - 1, z: zLocation + 2 }),
                player.dimension.getBlock({ x: xLocation + 2, y: y - 1, z: zLocation + 2 }),
            ];
            const blocks = [
                /*const blockAtPosition = player.dimension.getBlock(blockLocation);
                const blockEast1Above1 = player.dimension.getBlock({ x: xLocation + 1, y: y + 1, z: zLocation });
                const blockSouth1Above1 = player.dimension.getBlock({ x: xLocation, y: y + 1, z: zLocation + 1 });
                const blockEast2South1Above1 = player.dimension.getBlock({ x: xLocation + 2, y: y + 1, z: zLocation + 1 });
                const blockEast1South2Above1 = player.dimension.getBlock({ x: xLocation + 1, y: y + 1, z: zLocation + 2 });
                const blockEast1South1Above2 = player.dimension.getBlock({ x: xLocation + 1, y: y + 2, z: zLocation + 1 });
                const blockEast1South1Above1 = player.dimension.getBlock({ x: xLocation + 1, y: y + 1, z: zLocation + 1 });
                const blockEast1 = player.dimension.getBlock({ x: xLocation + 1, y: y, z: zLocation });
                const blockEast2 = player.dimension.getBlock({ x: xLocation + 2, y: y, z: zLocation });
                const blockSouth1 = player.dimension.getBlock({ x: xLocation, y: y, z: zLocation + 1 });
                const blockSouth2 = player.dimension.getBlock({ x: xLocation, y: y, z: zLocation + 2 });
                const blockEast1South1 = player.dimension.getBlock({ x: xLocation + 1, y: y, z: zLocation + 1 });
                const blockEast2South1 = player.dimension.getBlock({ x: xLocation + 2, y: y, z: zLocation + 1 });
                const blockEast1South2 = player.dimension.getBlock({ x: xLocation + 1, y: y, z: zLocation + 2 });
                const blockEast2South2 = player.dimension.getBlock({ x: xLocation + 2, y: y, z: zLocation + 2 });*/
                player.dimension.getBlock(blockLocation),
                player.dimension.getBlock({ x: xLocation + 1, y: y + 1, z: zLocation }),
                player.dimension.getBlock({ x: xLocation, y: y + 1, z: zLocation + 1 }),
                player.dimension.getBlock({ x: xLocation + 2, y: y + 1, z: zLocation + 1 }),
                player.dimension.getBlock({ x: xLocation + 1, y: y + 1, z: zLocation + 2 }),
                player.dimension.getBlock({ x: xLocation + 1, y: y + 2, z: zLocation + 1 }),
                player.dimension.getBlock({ x: xLocation + 1, y: y + 1, z: zLocation + 1 }),
                player.dimension.getBlock({ x: xLocation + 1, y: y, z: zLocation }),
                player.dimension.getBlock({ x: xLocation + 2, y: y, z: zLocation }),
                player.dimension.getBlock({ x: xLocation, y: y, z: zLocation + 1 }),
                player.dimension.getBlock({ x: xLocation, y: y, z: zLocation + 2 }),
                player.dimension.getBlock({ x: xLocation + 1, y: y, z: zLocation + 1 }),
                player.dimension.getBlock({ x: xLocation + 2, y: y, z: zLocation + 1 }),
                player.dimension.getBlock({ x: xLocation + 1, y: y, z: zLocation + 2 }),
                player.dimension.getBlock({ x: xLocation + 2, y: y, z: zLocation + 2 }),
            ];
            //world.sendMessage("blocks: " + blocks.every(block => (block.isAir || (block.typeId == "minecraft:snow_layer") || (block.typeId == "minecraft:short_grass"))));
            //world.sendMessage("blocksBelow: " + blocksBelow.every(blockBelow => !(blockBelow.isAir || blockBelow.isLiquid || (blockBelow.typeId == "minecraft:snow_layer") || (blockBelow.typeId == "minecraft:short_grass"))));
            if (blocks.every(block => (block && (block.isAir || !block.isLiquidBlocking("Water"))) && blocksBelow.every(blockBelow => !(blockBelow.isAir || !blockBelow.isLiquidBlocking("Water"))))) {
                return y
            }
        }
    }
    return null;
}

function getValidCoordinate(player, spawnRadius, minDistance, minY, ignoreBlocks) {
    if (ignoreBlocks == undefined)
        ignoreBlocks = false;
    if (minY == undefined)
        minY = spawnRadius;
    const center = player.location;
    const maxTries = 12;
    for (let attempt = 0; attempt < maxTries; attempt++) {
        const angle = Math.random() * 2 * Math.PI;
        const distance = minDistance + Math.random() * (spawnRadius - minDistance);
        const x = Math.floor(center.x + Math.cos(angle) * distance);
        const z = Math.floor(center.z + Math.sin(angle) * distance);
        const y = getValidYCoordinate(player, x, z, minY, ignoreBlocks);
        if (y != null) {
            return { x, y, z };
        }
    }
    return center;
}

function getValidYCoordinate(player, xLocation, zLocation, range, ignoreBlocks) {
    if (range == undefined)
        range = 10;
    if (ignoreBlocks == undefined)
        ignoreBlocks = false;
    let adjustedYOffset = 0;
    for (let yOffset = 0; yOffset <= range * 2; yOffset++) {
        if (yOffset == 1 && adjustedYOffset >= 0) {
            adjustedYOffset = -1;
        } else {
            if (adjustedYOffset <= 0) {
                adjustedYOffset = Math.abs(adjustedYOffset);
            } else {
                adjustedYOffset = -adjustedYOffset - 1;
            }
        }
        //world.sendMessage("adjustedYOffset: " + adjustedYOffset);
        const y = Math.floor(player.location.y) + adjustedYOffset;
        if (y >= -64 && y <= 320) {
            const blockLocation = { x: xLocation, y: y, z: zLocation };
            const blockAtPosition = player.dimension.getBlock(blockLocation);
            const blockAbove = player.dimension.getBlock({ x: xLocation, y: y + 1, z: zLocation });
            const blockAbove2 = player.dimension.getBlock({ x: xLocation, y: y + 2, z: zLocation });
            if (!blockAtPosition.isAir && !blockAtPosition.isLiquid && blockAtPosition.isLiquidBlocking("Water") && !blockAbove.isLiquidBlocking("Water") && !blockAbove2.isLiquidBlocking("Water")) {
                return y + 1;
            }
            else if (ignoreBlocks && !blockAtPosition.isAir && !blockAtPosition.isLiquid && blockAtPosition.isLiquidBlocking("Water")) {
                return y + 1;
            }
        }
    }
    return null;
}

function deleteTorch(mode, summoner) {
    if (playerTorchSpotList.length > 0) {
        const spot = playerTorchSpotList[Math.floor(Math.random() * playerTorchSpotList.length)];
        spot.dimension.getBlock(spot.location).setPermutation(BlockPermutation.resolve("minecraft:air"));
        if (summoner)
            summoner.sendMessage("§7A random Torch was successfully removed.§r");
    }
    else if (summoner)
        summoner.sendMessage("§cThere are no Torches available to remove.§r");
}

world.afterEvents.playerJoin.subscribe(async ({ playerId, playerName }) => {
    system.runTimeout(() => {
        const players = world.getPlayers({name: playerName,});
        const player = players[0];
        applyFog(player);
        //world.sendMessage("Attempted to reapply fog to " + player.name + ".");
    }, 120);
});

function applyFog(player) {
    if (player != undefined) {
        player.runCommand("fog @s pop zpig:herobrine_fog");
        player.runCommand("fog @s pop zpig:heavy_calamity_fog");
        player.runCommand("fog @s pop zpig:calamity_fog");
        player.runCommand("fog @s pop zpig:day_of_calamity_fog");
        if (player.getGameMode() != "spectator") {
            if (world.getDynamicProperty("herobrine_fog_day") && !world.getDynamicProperty("calamity_fog_active")) {
                player.runCommand("fog @s push zpig:herobrine_fog zpig:herobrine_fog");
            }
            else if (world.getDynamicProperty("herobrine_fog_day") && world.getDynamicProperty("calamity_fog_active")) {
                player.runCommand("fog @s push zpig:calamity_fog zpig:calamity_fog");
                player.runCommand("fog @s push zpig:heavy_calamity_fog zpig:heavy_calamity_fog");
            }
            else if (!world.getDynamicProperty("herobrine_fog_day") && world.getDynamicProperty("calamity_fog_active")) {
                player.runCommand("fog @s push zpig:calamity_fog zpig:calamity_fog");
            }
            if (world.getDynamicProperty("is_day_of_calamity")) {
                player.runCommand("fog @s push zpig:day_of_calamity_fog zpig:day_of_calamity_fog");
            }
        }
    }
}

system.runInterval(() => {
    for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
        if (player.getDynamicProperty("herobrine_anger") == null) {
            player.setDynamicProperty("herobrine_anger", 1);
            //world.sendMessage(player.name + "'s Herobrine Anger: " + player.getDynamicProperty("herobrine_anger"));
        }
        if (player.getDynamicProperty("herobrine_anger_decay_timer") == null) {
            player.setDynamicProperty("herobrine_anger_decay_timer", 900);
            //world.sendMessage(player.name + "'s Herobrine Anger: " + player.getDynamicProperty("herobrine_anger"));
        }
        if (player.getDynamicProperty("herobrine_timer") == null) {
            player.setDynamicProperty("herobrine_timer", -1);
        }
        if (player.getDynamicProperty("herobrine_sign_timer") == null) {
            player.setDynamicProperty("herobrine_sign_timer", -1);
        }
        if (player.getDynamicProperty("herobrine_altar_timer") == null) {
            player.setDynamicProperty("herobrine_altar_timer", -1);
        }
        if (player.getDynamicProperty("herobrine_ambience_timer") == null) {
            player.setDynamicProperty("herobrine_ambience_timer", -1);
        }
        if (player.getDynamicProperty("herobrine_footsteps_timer") == null) {
            player.setDynamicProperty("herobrine_footsteps_timer", -1);
        }
        if (player.getDynamicProperty("remove_day_50_calamity_fog_timer") == null) {
            player.setDynamicProperty("remove_day_50_calamity_fog_timer", -1);
        }
        if (player.getDynamicProperty("white_eyes_counter_timer") == null) {
            player.setDynamicProperty("white_eyes_counter_timer", -1);
        }
        if (player.getDynamicProperty("calamity_enemy_summon_timer") == null) {
            player.setDynamicProperty("calamity_enemy_summon_timer", -1);
        }
        //world.sendMessage("Herobrine's Nightmare Rate is " + (((0.05 + ((herobrineNightmareRate - 1) / 10)) + (herobrineActivityRate / 20)) * 100).toFixed(2) + " percent chance when sleeping.");
        //world.sendMessage("Herobrine Anger: " + player.getDynamicProperty("herobrine_anger"));
        if (player.isSleeping && (!player.hasTag("zpig:sleeping"))) {
            player.addTag("zpig:sleeping");
            //player.sendMessage("Good night.");
            const spawnRadius = 3;
            const minDistance = 1;
            let randomX, randomZ;
            do {
                randomX = Math.floor(player.location.x + (Math.random() * 2 - 1) * spawnRadius);
                randomZ = Math.floor(player.location.z + (Math.random() * 2 - 1) * spawnRadius);
            } while (Math.sqrt(Math.pow(randomX - player.location.x, 2) + Math.pow(randomZ - player.location.z, 2)) < minDistance);
            const validY = (player.location.y - 0.6);
            if (world.getDynamicProperty("herobrine_nightmare_day") || player.hasTag("zpig:summon_herobrine_nightmare_function")) {
                const herobrine = player.dimension.spawnEntity("zpig:herobrine_nightmare_setup_entity", { x: randomX, y: validY, z: randomZ });
                facePlayer(player, herobrine);
            }
            //player.sendMessage("commandFeedback: " + world.gameRules.sendCommandFeedback);
        }
        if (!player.isSleeping && player.hasTag("zpig:sleeping") && !(player.hasTag("zpig:victim_setup") || player.hasTag("zpig:victim"))) {
            player.runCommand("event entity @e [type=zpig:herobrine,c=1,tag=zpig:herobrine_nightmare_start] zpig:leave_short");
            player.runCommand("stopsound @s");
            player.removeTag("zpig:sleeping");
        }
        if (player.hasTag("zpig:victim_setup")) {
            player.addTag("zpig:victim");
            player.removeTag("zpig:victim_setup");
            player.removeTag("zpig:summon_herobrine_nightmare_function");
            if (!world.gameRules.sendCommandFeedback) {
                player.runCommand("tp @s ~ ~ ~ ~ 0");
                player.runCommand("tp @e [type=zpig:herobrine,tag=zpig:herobrine_nightmare,c=1] ^ ^ ^4 facing @s");
            }
            else {
                world.gameRules.sendCommandFeedback = false;
                player.runCommand("tp @s ~ ~ ~ ~ 0");
                player.runCommand("tp @e [type=zpig:herobrine,tag=zpig:herobrine_nightmare,c=1] ^ ^ ^4 facing @s");
                world.gameRules.sendCommandFeedback = true;
            }
        }
        if (player.hasTag("zpig.reset_herobrine_anger")) {
            player.removeTag("zpig.reset_herobrine_anger");
            player.setDynamicProperty("herobrine_anger", 1);
            //world.sendMessage(player.name + "'s Herobrine Anger: " + player.getDynamicProperty("herobrine_anger"));
        }
        if (player.hasTag("zpig:summon_herobrine_function")) {
            player.removeTag("zpig:summon_herobrine_function");
            summonHerobrine(player, 0, 1);
        }
        if (player.hasTag("zpig:summon_herobrine_stalk_function")) {
            player.removeTag("zpig:summon_herobrine_stalk_function");
            summonHerobrine(player, 0, 2);
        }
        if (player.hasTag("zpig:summon_herobrine_glimpse_function")) {
            player.removeTag("zpig:summon_herobrine_glimpse_function");
            summonHerobrine(player, 0, 4);
        }
        if (player.hasTag("zpig:summon_herobrine_dont_turn_around_function")) {
            player.removeTag("zpig:summon_herobrine_dont_turn_around_function");
            summonHerobrine(player, 0, 5);
        }
        if (player.hasTag("zpig:summon_herobrine_attack_function")) {
            player.removeTag("zpig:summon_herobrine_attack_function");
            summonHerobrine(player, 0, 3);
        }
        if (player.hasTag("zpig:summon_herobrine_sign_function")) {
            player.removeTag("zpig:summon_herobrine_sign_function");
            writeMessage(player, 1);
        }
        if (player.hasTag("zpig:summon_herobrine_special_sign_function")) {
            player.removeTag("zpig:summon_herobrine_special_sign_function");
            writeMessage(player, 2);
        }
        if (player.hasTag("zpig:summon_herobrine_torch_deepslate_function")) {
            player.removeTag("zpig:summon_herobrine_torch_deepslate_function");
            torchDeepslate(player, 1);
        }
        if (player.hasTag("zpig:summon_herobrine_altar_function")) {
            player.removeTag("zpig:summon_herobrine_altar_function");
            spawnAltar(player, 1);
        }
        if (player.hasTag("zpig:play_herobrine_stone_footsteps_function")) {
            player.removeTag("zpig:play_herobrine_stone_footsteps_function");
            walkStone(player, 1);
        }
        if (player.hasTag("zpig:play_herobrine_ambience_function")) {
            player.removeTag("zpig:play_herobrine_ambience_function");
            playAmbience(player, 1);
        }
        if (player.hasTag("zpig:summon_herobrine_boss_function")) {
            player.removeTag("zpig:summon_herobrine_boss_function");
            summonHerobrineBoss(player, player.location, 1);
        }
        if (player.hasTag("zpig:open_herobrine_menu")) {
            player.removeTag("zpig:open_herobrine_menu");
            openHerobrineMenu(player);
        }
        if (world.getDynamicProperty("is_day_of_calamity") && player.getDynamicProperty("calamity_enemy_summon_timer") < 0 && (player.getGameMode() == "survival" || player.getGameMode() == "adventure")) {
            player.setDynamicProperty("calamity_enemy_summon_timer", Math.trunc(3 * (Math.random() * (1.5 - 0.5) + 0.5)));
        }
        for (const herobrine of herobrineList) {
            if (herobrine.getComponent("skin_id") && herobrine.getComponent("skin_id").value == 11 && !herobrine.hasComponent("is_baby")) {
                if (isEntityOnScreen(player, herobrine, 0.6)) {
                    player.runCommand("playsound ambient.cave @s");
                    herobrine.runCommand("event entity @s zpig:leave_blink");
                    let anger = player.getDynamicProperty("herobrine_anger");
                    player.setDynamicProperty("herobrine_anger", (anger + 1));
                    //world.sendMessage(player.name + "'s Herobrine Anger: " + player.getDynamicProperty("herobrine_anger"));
                }
            }
            else if (player.hasTag("zpig:herobrine_behind_player") && herobrine.getComponent("skin_id") && herobrine.getComponent("skin_id").value == 12 && !herobrine.hasComponent("is_baby")) {
                if (isEntityOnScreen(player, herobrine, 0.6, true)) {
                    herobrine.runCommand("event entity @s zpig:leave_blink");
                    let anger = player.getDynamicProperty("herobrine_anger");
                    player.setDynamicProperty("herobrine_anger", (anger + 1));
                    //world.sendMessage(player.name + "'s Herobrine Anger: " + player.getDynamicProperty("herobrine_anger"));
                }
            }
            else if (herobrine.getComponent("skin_id") && herobrine.getComponent("skin_id").value == 1 && !herobrine.hasComponent("is_baby")) {
                if (isEntityOnScreen(player, herobrine, 0.975)) {
                    player.runCommand("playsound ambient.cave @s");
                    herobrine.runCommand("event entity @s zpig:leave_blink");
                    let anger = player.getDynamicProperty("herobrine_anger");
                    player.setDynamicProperty("herobrine_anger", (anger + 1));
                    //world.sendMessage(player.name + "'s Herobrine Anger: " + player.getDynamicProperty("herobrine_anger"));
                }
            }
            else if (herobrine.getComponent("skin_id") && herobrine.getComponent("skin_id").value == 2 && !herobrine.hasTag("zpig:herobrine_attacking")) {
                if (isEntityOnScreen(player, herobrine, 0.975)) {
                    herobrine.runCommand("event entity @s zpig:mode_2_attack");
                    herobrine.addTag("zpig:herobrine_attacking");
                    player.runCommand("playsound mob.herobrine.scream @s ^ ^ ^1 45");
                    player.runCommand("playsound mob.herobrine.scream_overlay @s ^ ^ ^1 40 0.8");
                    player.runCommand("tp @e [type=zpig:herobrine,tag=zpig:herobrine_attacking,c=1] ^ ^ ^0.4 facing @s");
                    let anger = player.getDynamicProperty("herobrine_anger");
                    player.setDynamicProperty("herobrine_anger", (anger + 1));
                    //world.sendMessage(player.name + "'s Herobrine Anger: " + player.getDynamicProperty("herobrine_anger"));
                }
            }
        }
        const entitiesInView = player.getEntitiesFromViewDirection();
        entitiesInView.forEach((hit) => {
            if (hit.entity != undefined && hit.entity.typeId == "zpig:herobrine") {
                if (hit.entity != undefined && (hit.entity.getComponent("skin_id").value == 1 || hit.entity.getComponent("skin_id").value == 11)) {
                    player.runCommand("playsound ambient.cave @s");
                    hit.entity.runCommand("event entity @s zpig:leave_short");
                    let anger = player.getDynamicProperty("herobrine_anger");
                    player.setDynamicProperty("herobrine_anger", (anger + 1));
                    //world.sendMessage(player.name + "'s Herobrine Anger: " + player.getDynamicProperty("herobrine_anger"));
                }
                else if (hit.entity.getComponent("skin_id").value == 2 && !hit.entity.hasTag("zpig:herobrine_attacking")) {
                    hit.entity.runCommand("event entity @s zpig:mode_2_attack");
                    hit.entity.addTag("zpig:herobrine_attacking");
                    player.runCommand("playsound mob.herobrine.scream @s ^ ^ ^1 45");
                    player.runCommand("playsound mob.herobrine.scream_overlay @s ^ ^ ^1 40 0.8");
                    player.runCommand("tp @e [type=zpig:herobrine,tag=zpig:herobrine_attacking,c=1] ^ ^ ^0.4 facing @s");
                    let anger = player.getDynamicProperty("herobrine_anger");
                    player.setDynamicProperty("herobrine_anger", (anger + 1));
                    //world.sendMessage(player.name + "'s Herobrine Anger: " + player.getDynamicProperty("herobrine_anger"));
                }
            }
        });
    }
    for (const player of world.getPlayers()) {
        if (player.hasTag("zpig:calamity_target") && !world.getDynamicProperty("is_day_of_calamity")) {
            player.removeTag("zpig:calamity_target");
        }
    }
    for (const spot of playerTorchSpotList) {
        if (spot && spot.dimension.getBlock(spot.location).typeId != "minecraft:torch") {
            spot.remove();
            //world.sendMessage("Player Torch Broken.");
            //data.block.setPermutation(BlockPermutation.resolve("minecraft:dirt"));
        }
    }
    for (const torch of herobrineTorches) {
        if (torch.isValid && torch.typeId != "minecraft:redstone_torch") {
            herobrineTorches.splice(herobrineTorches.indexOf(torch), 1);
            //world.sendMessage("Herobrine's Torch Broken.");
            world.getDimension("overworld").playSound("ambient.cave", torch.location);
            //data.block.setPermutation(BlockPermutation.resolve("minecraft:dirt"));
        }
    }
    for (const spot of herobrineSignSpotList) {
        const sign = spot.dimension.getBlock(spot.location);
        if (spot && sign.typeId != "minecraft:standing_sign") {
            //world.sendMessage("Herobrine's Sign Broken.");
            const players = sign.dimension.getEntities({
                location: sign.location,
                closest: 1,
                maxDistance: 8,
                type: 'minecraft:player',
                excludeGameModes: ['spectator'],
            });
            if (players.length > 0) {
                increaseAnger(players[0], 1);
            }
            world.getDimension("overworld").playSound("ambient.cave", spot.location);
            spot.remove();
        }
    }
    for (const spot of playerSignSpotList) {
        const sign = spot.dimension.getBlock(spot.location)
        if (spot && sign.typeId != "minecraft:standing_sign") {
            //world.sendMessage("Player Sign Broken.");
            spot.remove();
        }
        else if (sign.isValid) {
            const xLocation = sign.location.x - 1;
            const y = sign.location.y - 2;
            const zLocation = sign.location.z - 1;
            const text = sign.getComponent("minecraft:sign").getText();
            const blockAtPosition = sign.dimension.getBlock({ x: xLocation, y: y, z: zLocation });
            const blockEast1Above1 = sign.dimension.getBlock({ x: xLocation + 1, y: y + 1, z: zLocation });
            const blockSouth1Above1 = sign.dimension.getBlock({ x: xLocation, y: y + 1, z: zLocation + 1 });
            const blockEast2South1Above1 = sign.dimension.getBlock({ x: xLocation + 2, y: y + 1, z: zLocation + 1 });
            const blockEast1South2Above1 = sign.dimension.getBlock({ x: xLocation + 1, y: y + 1, z: zLocation + 2 });
            const blockEast1South1Above1 = sign.dimension.getBlock({ x: xLocation + 1, y: y + 1, z: zLocation + 1 });
            const blockEast1 = sign.dimension.getBlock({ x: xLocation + 1, y: y, z: zLocation });
            const blockEast2 = sign.dimension.getBlock({ x: xLocation + 2, y: y, z: zLocation });
            const blockSouth1 = sign.dimension.getBlock({ x: xLocation, y: y, z: zLocation + 1 });
            const blockSouth2 = sign.dimension.getBlock({ x: xLocation, y: y, z: zLocation + 2 });
            const blockEast1South1 = sign.dimension.getBlock({ x: xLocation + 1, y: y, z: zLocation + 1 });
            const blockEast2South1 = sign.dimension.getBlock({ x: xLocation + 2, y: y, z: zLocation + 1 });
            const blockEast1South2 = sign.dimension.getBlock({ x: xLocation + 1, y: y, z: zLocation + 2 });
            const blockEast2South2 = sign.dimension.getBlock({ x: xLocation + 2, y: y, z: zLocation + 2 });
            let bossCount = 0;
            for (const herobrine of herobrineList) {
                if ((herobrine.getComponent("skin_id").value == 4) || (herobrine.getComponent("skin_id").value == 41)) {
                    bossCount++;
                }
            }
            //world.sendMessage("text.toLowerCase(): " + text.toLowerCase());
            if ((text.toLowerCase() == "reveal the true enemy" || text.toLowerCase() == "reveal the true enemy.") && herobrineActivity && bossCount < 1 &&
                (
                    blockEast1Above1.typeId == "minecraft:redstone_torch" &&
                    blockSouth1Above1.typeId == "minecraft:redstone_torch" &&
                    blockEast2South1Above1.typeId == "minecraft:redstone_torch" &&
                    blockEast1South2Above1.typeId == "minecraft:redstone_torch" &&
                    blockEast1South1Above1.typeId == "minecraft:netherrack" &&
                    blockAtPosition.typeId == "minecraft:gold_block" &&
                    blockEast1.typeId == "minecraft:gold_block" &&
                    blockEast2.typeId == "minecraft:gold_block" &&
                    blockSouth1.typeId == "minecraft:gold_block" &&
                    blockSouth2.typeId == "minecraft:gold_block" &&
                    blockEast1South1.typeId == "minecraft:gold_block" &&
                    blockEast2South1.typeId == "minecraft:gold_block" &&
                    blockEast1South2.typeId == "minecraft:gold_block" &&
                    blockEast2South2.typeId == "minecraft:gold_block"
                )
            ) {
                sign.setPermutation(BlockPermutation.resolve("minecraft:air"));
                blockEast1Above1.setPermutation(BlockPermutation.resolve("minecraft:air"));
                blockSouth1Above1.setPermutation(BlockPermutation.resolve("minecraft:air"));
                blockEast2South1Above1.setPermutation(BlockPermutation.resolve("minecraft:air"));
                blockEast1South2Above1.setPermutation(BlockPermutation.resolve("minecraft:air"));
                blockEast1South1Above1.setPermutation(BlockPermutation.resolve("minecraft:air"));
                blockAtPosition.setPermutation(BlockPermutation.resolve("minecraft:air"));
                blockEast1.setPermutation(BlockPermutation.resolve("minecraft:air"));
                blockEast2.setPermutation(BlockPermutation.resolve("minecraft:air"));
                blockSouth1.setPermutation(BlockPermutation.resolve("minecraft:air"));
                blockSouth2.setPermutation(BlockPermutation.resolve("minecraft:air"));
                blockEast1South1.setPermutation(BlockPermutation.resolve("minecraft:air"));
                blockEast2South1.setPermutation(BlockPermutation.resolve("minecraft:air"));
                blockEast1South2.setPermutation(BlockPermutation.resolve("minecraft:air"));
                blockEast2South2.setPermutation(BlockPermutation.resolve("minecraft:air"));
                const targetList = sign.dimension.getPlayers({
                    location: sign.location,
                    closest: 1,
                    excludeGameModes: ['spectator'],
                });
                for (const target of targetList) {
                    summonHerobrineBoss(target, sign.location, 0);
                }
            }
        }
    }
    for (const spot of herobrineSpecialSignSpotList) {
        const sign = spot.dimension.getBlock(spot.location);
        if (spot && sign.typeId != "minecraft:standing_sign") {
            const players = sign.dimension.getEntities({
                location: sign.location,
                closest: 1,
                maxDistance: 8,
                type: 'minecraft:player',
                excludeGameModes: ['spectator'],
            });
            if (players.length > 0) {
                increaseAnger(players[0], 2);
            }
            spot.dimension.spawnEntity("minecraft:lightning_bolt", spot.location);
            //world.sendMessage("Herobrine's Special Sign Broken.");
            spot.remove();
        }

    }
    if (world.getTimeOfDay() == 0) {
        //world.sendMessage("Nightmare Rate: " + herobrineNightmareRate);
        if (herobrineActivity && world.getDay() >= 1) {
            processNightmareDay(0);
            processFogDay(0);
        }
        if (calamityEnabled) {
            processCalamityDay(0);
        }
    }
});

function day50CalamityEvent() {
    for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
        player.runCommand("camerashake add @s 0.075 10");
        player.playSound("random.calamity_rumble");
    }
    system.runTimeout(() => {
        for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
            player.runCommand("title @s title zpig.display_calamity_eyes");
            //player.playSound("mob.white_eyes.teleport", { pitch: (Math.random() * (1.2 - 0.8) + 0.8) });
        }
    }, 80);
    system.runTimeout(() => {
        for (const player of world.getPlayers()) {
            player.runCommand("title @s title zpig.remove_calamity_eyes");
        }
    }, 85);
    system.runTimeout(() => {
        for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
            player.runCommand("title @s title zpig.display_calamity_eyes");
            //player.playSound("mob.white_eyes.teleport", { pitch: (Math.random() * (1.2 - 0.8) + 0.8) });
        }
    }, 120);
    system.runTimeout(() => {
        for (const player of world.getPlayers()) {
            player.runCommand("title @s title zpig.remove_calamity_eyes");
        }
    }, 125);
    system.runTimeout(() => {
        for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
            player.runCommand("title @s title zpig.display_calamity_eyes");
            player.playSound("mob.white_eyes.teleport", { pitch: (Math.random() * (1.2 - 0.8) + 0.8) });
        }
    }, 130);
    system.runTimeout(() => {
        for (const player of world.getPlayers()) {
            player.runCommand("title @s title zpig.remove_calamity_eyes");
        }
    }, 140);
    system.runTimeout(() => {
        for (const player of world.getPlayers()) {
            player.runCommand("title @s actionbar 50 days remaining until Calamity");
        }
    }, 220);
}

system.runInterval(() => {
    if (calamityEnabled)
        processCalamityDay(2);
}, 60);

function calamityBadEnding() {
    //world.sendMessage("The End");
    world.setDynamicProperty("is_day_of_calamity", false);
    if (whiteEyesCalamityList.length > 0) {
        const whiteEyes = whiteEyesCalamityList[0];
        whiteEyes.triggerEvent("zpig:scream");
    }
    for (const player of world.getPlayers()) {
        player.runCommand("camerashake add @s 0.075 4");
        player.playSound("random.calamity_rumble_short");
        player.runCommand("camera @s fade time 5 8 1 color 255 255 255");
    }
    system.runTimeout(() => {
        world.getDimension("overworld").setWeather("Clear");
        daysUntilCalamity = 100;
        world.setDynamicProperty("days_until_calamity", 100);
        if (world.getDynamicProperty("herobrine_defeated") == true) {
            world.setDynamicProperty("herobrine_defeated", false);
            world.setDynamicProperty("herobrine_activity", true);
            herobrineActivity = true;
        }
        processCalamityDay(1);
        whiteEyesCalamityList.forEach((whiteEyes) => {
            whiteEyes.remove();
        });
        for (const player of world.getPlayers()) {
            player.runCommand("stopsound @s mob.white_eyes_calamity.loop");
            player.runCommand("fog @s pop zpig:calamity_fog");
            player.runCommand("fog @s pop zpig:heavy_calamity_fog");
            player.runCommand("fog @s pop zpig:day_of_calamity_fog");
            const actionForm = new ActionFormData().title("You failed to stop the Calamity...");
            actionForm.body("\nYou failed to stop the Calamity. Time will be reset and you will have another 100 days to attempt to prevent the Calamity from occuring.\n\nThe key to stopping the Calamity can be found by building an altar.\n\n\n\n\n\n");
            actionForm.button("Close");
            actionForm.show(player);
        }
    }, 100);
}

function processCalamityDay(mode) {
    if (daysUntilCalamity >= 0 && mode == 0) {
        daysUntilCalamity--;
        world.setDynamicProperty("days_until_calamity", daysUntilCalamity);
        //world.sendMessage("Days until Calamity: " + daysUntilCalamity);
    }
    else if (daysUntilCalamity <= -1 && world.getDynamicProperty("is_day_of_calamity") && mode <= 3) {
        calamityBadEnding();
    }
    if (daysUntilCalamity == 50 && mode <= 1) {
        //world.sendMessage("Day 50 Calamity Event");
        for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
            player.runCommand("fog @s push zpig:day_50_calamity_fog zpig:day_50_calamity_fog");
            player.setDynamicProperty("remove_day_50_calamity_fog_timer", 14);
        }
        system.runTimeout(() => {
            day50CalamityEvent();
        }, 60);
    }
    if (daysUntilCalamity <= 10 && daysUntilCalamity > 0 && mode <= 1) {
        if (!world.getDynamicProperty("calamity_fog_active")) {
            world.setDynamicProperty("calamity_fog_active", true);
            for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
                player.runCommand("fog @s push zpig:calamity_fog zpig:calamity_fog");
            }
            if (world.getDynamicProperty("herobrine_fog_day")) {
                for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
                    player.runCommand("fog @s push zpig:heavy_calamity_fog zpig:heavy_calamity_fog");
                }
                for (const player of world.getPlayers()) {
                    player.runCommand("fog @s pop zpig:herobrine_fog");
                }
            }
        }
    }
    else if ((daysUntilCalamity > 10 || daysUntilCalamity <= 0) && world.getDynamicProperty("calamity_fog_active") && mode <= 1) {
        world.setDynamicProperty("calamity_fog_active", false);
        for (const player of world.getPlayers()) {
            player.runCommand("fog @s pop zpig:calamity_fog");
            player.runCommand("fog @s pop zpig:heavy_calamity_fog");
        }
        if (world.getDynamicProperty("herobrine_fog_day")) {
            for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
                player.runCommand("fog @s push zpig:herobrine_fog zpig:herobrine_fog");
            }
        }
    }
    if (daysUntilCalamity <= 0 && !world.getDynamicProperty("is_day_of_calamity") && mode <= 1) {
        world.setDynamicProperty("is_day_of_calamity", true);
        for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
            player.runCommand("fog @s push zpig:day_of_calamity_fog zpig:day_of_calamity_fog");
            player.runCommand("camerashake add @s 0.075 10");
            player.playSound("random.calamity_rumble");
            player.playSound("mob.white_eyes_calamity.scream", { volume: 0.25 });
        }
        for (const player of world.getPlayers()) {
            player.runCommand("title @s actionbar The day of Calamity is upon us");
        }
        whiteEyesList.forEach((whiteEyes) => {
            whiteEyes.remove();
        });
        world.getDimension("overworld").setWeather("Thunder", 24000);
        if (whiteEyesCalamityList.length <= 0 && calamitySpawnerList.length <= 0) {
            const calamityTargetsSurvival = world.getDimension("overworld").getPlayers({
                excludeGameModes: ['creative', 'spectator'],
            });
            const calamityTargetsCreative = world.getDimension("overworld").getPlayers({
                excludeGameModes: ['spectator'],
            });
            const calamityTargetsSpectator = world.getDimension("overworld").getPlayers({
                excludeGameModes: ['spectator'],
            });
            //world.sendMessage("calamityTargetsSurvival.length: " + calamityTargetsSurvival.length);
            //world.sendMessage("calamityTargetsCreative.length: " + calamityTargetsCreative.length);
            if (calamityTargetsSurvival.length > 0) {
                const player = calamityTargetsSurvival[Math.floor(Math.random() * calamityTargetsSurvival.length)];
                if (player != undefined) {
                    const calamitySpawner = world.getDimension("overworld").spawnEntity("zpig:calamity_spawner_entity", player.location);
                    calamitySpawnerLogic(calamitySpawner, player);
                }
            }
            else if (calamityTargetsCreative.length > 0) {
                const player = calamityTargetsCreative[Math.floor(Math.random() * calamityTargetsCreative.length)];
                if (player != undefined) {
                    const calamitySpawner = world.getDimension("overworld").spawnEntity("zpig:calamity_spawner_entity", player.location);
                    calamitySpawnerLogic(calamitySpawner, player);
                }
            }
            else {
                const player = calamityTargetsSpectator[Math.floor(Math.random() * calamityTargetsSpectator.length)];
                if (player != undefined) {
                    const calamitySpawner = world.getDimension("overworld").spawnEntity("zpig:calamity_spawner_entity", player.location);
                    calamitySpawnerLogic(calamitySpawner, player);
                }
            }
        }
    }
    if (daysUntilCalamity > 0 && world.getDynamicProperty("is_day_of_calamity") && mode <= 1) {
        world.setDynamicProperty("is_day_of_calamity", false);
        for (const player of world.getPlayers()) {
            player.runCommand("fog @s pop zpig:day_of_calamity_fog");
            player.runCommand("stopsound @s mob.white_eyes_calamity.loop");
        }
        calamitySpawnerList.forEach((calamitySpawner) => {
            calamitySpawner.remove();
        });
        whiteEyesCalamityList.forEach((whiteEyes) => {
            whiteEyes.remove();
        });
    }
    if (daysUntilCalamity <= 10 && daysUntilCalamity > 0 && mode <= 1) {
        if (daysUntilCalamity > 1) {
            for (const player of world.getPlayers()) {
                player.runCommand("title @s actionbar " + daysUntilCalamity + " days remaining until Calamity");
            }
        }
        else {
            for (const player of world.getPlayers()) {
                player.runCommand("title @s actionbar " + daysUntilCalamity + " day remaining until Calamity");
            }
        }
    }
    /*world.sendMessage("daysUntilCalamity: " + daysUntilCalamity);
    world.sendMessage("world.getDynamicProperty(\"is_day_of_calamity\"): " + world.getDynamicProperty("is_day_of_calamity"));
    world.sendMessage("whiteEyesCalamityList.length: " + whiteEyesCalamityList.length);
    world.sendMessage("calamitySpawnerList.length: " + calamitySpawnerList.length);
    world.sendMessage("mode: " + mode);*/
    if (daysUntilCalamity <= 0 && world.getDynamicProperty("is_day_of_calamity") && whiteEyesCalamityList.length <= 0 && calamitySpawnerList.length <= 0 && mode == 2) {
        const calamityTargetsSurvival = world.getDimension("overworld").getPlayers({
            excludeGameModes: ['creative', 'spectator'],
        });
        const calamityTargetsCreative = world.getDimension("overworld").getPlayers({
            excludeGameModes: ['spectator'],
        });
        const calamityTargetsSpectator = world.getDimension("overworld").getPlayers({
        });
        //world.sendMessage("calamityTargetsSurvival.length: " + calamityTargetsSurvival.length);
        //world.sendMessage("calamityTargetsCreative.length: " + calamityTargetsCreative.length);
        if (calamityTargetsSurvival.length > 0) {
            const player = calamityTargetsSurvival[Math.floor(Math.random() * calamityTargetsSurvival.length)];
            if (player != undefined) {
                player.addTag("zpig:calamity_target");
                const calamitySpawner = world.getDimension("overworld").spawnEntity("zpig:calamity_spawner_entity", player.location);
                calamitySpawnerLogic(calamitySpawner, player);
            }
        }
        else if (calamityTargetsCreative.length > 0) {
            const player = calamityTargetsCreative[Math.floor(Math.random() * calamityTargetsCreative.length)];
            if (player != undefined) {
                player.addTag("zpig:calamity_target");
                const calamitySpawner = world.getDimension("overworld").spawnEntity("zpig:calamity_spawner_entity", player.location);
                calamitySpawnerLogic(calamitySpawner, player);
            }
        }
        else {
            const player = calamityTargetsSpectator[Math.floor(Math.random() * calamityTargetsSpectator.length)];
            if (player != undefined) {
                const calamitySpawner = world.getDimension("overworld").spawnEntity("zpig:calamity_spawner_entity", player.location);
                calamitySpawnerLogic(calamitySpawner, player);
            }
        }
    }
    if (mode == 3) {
        if (world.getDynamicProperty("is_day_of_calamity")) {
            world.getDimension("overworld").setWeather("Clear");
        }
        world.setDynamicProperty("calamity_fog_active", false);
        world.setDynamicProperty("is_day_of_calamity", false);
        for (const player of world.getPlayers()) {
            player.runCommand("fog @s pop zpig:day_of_calamity_fog");
            player.runCommand("fog @s pop zpig:calamity_fog");
            player.runCommand("fog @s pop zpig:heavy_calamity_fog");
            player.runCommand("stopsound @s mob.white_eyes_calamity.loop");
        }
        calamitySpawnerList.forEach((calamitySpawner) => {
            calamitySpawner.remove();
        });
        whiteEyesList.forEach((whiteEyes) => {
            whiteEyes.remove();
        });
        whiteEyesCalamityList.forEach((whiteEyes) => {
            whiteEyes.remove();
        });
    }
}

function processNightmareDay(mode, summoner) {
    if (mode == 0) {
        if (herobrineNightmareRate >= 20 || (herobrineNightmareRate > 0 && herobrineActivityRate > 0 && ((Math.pow(herobrineActivityRate, 0.585) * herobrineNightmareRate) / 76.91) >= (Math.random() + (world.getDynamicProperty("herobrine_nightmare_days_in_a_row") / 5)))) {
            world.setDynamicProperty("herobrine_nightmare_day", true);
            world.setDynamicProperty("herobrine_nightmare_days_in_a_row", world.getDynamicProperty("herobrine_nightmare_days_in_a_row") + 1);
        }
        else if (world.getDynamicProperty("herobrine_nightmare_days_in_a_row") > 0) {
            world.setDynamicProperty("herobrine_nightmare_day", false);
            world.setDynamicProperty("herobrine_nightmare_days_in_a_row", 0);
        }
        //world.sendMessage("Nightmare Day: " + world.getDynamicProperty("herobrine_nightmare_day"));
        //world.sendMessage("Nightmare Days In A Row: " + world.getDynamicProperty("herobrine_nightmare_days_in_a_row"));
    }
    else {
        if (world.getDynamicProperty("herobrine_nightmare_day")) {
            world.setDynamicProperty("herobrine_nightmare_day", false);
            if (summoner)
                summoner.sendMessage("§7Today is no longer a Herobrine Nightmare day.§r");
        }
        else {
            world.setDynamicProperty("herobrine_nightmare_day", true);
            if (summoner)
                summoner.sendMessage("§7Successfully set today as a Herobrine Nightmare day.§r");
        }
    }
}

function processFogDay(mode, summoner) {
    if (mode == 0) {
        if (herobrineFogRate >= 20 || (herobrineFogRate > 0 && herobrineActivityRate > 0 && ((Math.pow(herobrineActivityRate, 0.585) * herobrineFogRate) / 76.91) >= (Math.random() + (world.getDynamicProperty("herobrine_fog_days_in_a_row") / 5)))) {
            if (world.getDynamicProperty("herobrine_fog_day")) {
                world.setDynamicProperty("herobrine_fog_days_in_a_row", world.getDynamicProperty("herobrine_fog_days_in_a_row") + 1);
            }
            else if (!world.getDynamicProperty("calamity_fog_active")) {
                world.setDynamicProperty("herobrine_fog_day", true);
                world.setDynamicProperty("herobrine_fog_days_in_a_row", world.getDynamicProperty("herobrine_fog_days_in_a_row") + 1);
                for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
                    player.runCommand("fog @s push zpig:herobrine_fog zpig:herobrine_fog");
                }
            }
            else {
                world.setDynamicProperty("herobrine_fog_day", true);
                world.setDynamicProperty("herobrine_fog_days_in_a_row", world.getDynamicProperty("herobrine_fog_days_in_a_row") + 1);
                for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
                    player.runCommand("fog @s push zpig:heavy_calamity_fog zpig:heavy_calamity_fog");
                }
            }
        }
        else if (world.getDynamicProperty("herobrine_fog_day")) {
            world.setDynamicProperty("herobrine_fog_day", false);
            world.setDynamicProperty("herobrine_fog_days_in_a_row", 0);
            for (const player of world.getPlayers()) {
                player.runCommand("fog @s pop zpig:herobrine_fog");
                player.runCommand("fog @s pop zpig:heavy_calamity_fog");
            }
        }
        world.sendMessage("Fog Day: " + world.getDynamicProperty("herobrine_fog_day"));
        world.sendMessage("Fog Days In A Row: " + world.getDynamicProperty("herobrine_fog_days_in_a_row"));
    }
    else if (mode == 1) {
        if (world.getDynamicProperty("herobrine_fog_day")) {
            if (summoner)
                summoner.sendMessage("§7Today is already a Herobrine Fog day.§r");
        }
        else {
            world.setDynamicProperty("herobrine_fog_day", true);
            if (!world.getDynamicProperty("calamity_fog_active")) {
                for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
                    player.runCommand("fog @s push zpig:herobrine_fog zpig:herobrine_fog");
                }
            }
            else {
                for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
                    player.runCommand("fog @s push zpig:heavy_calamity_fog zpig:heavy_calamity_fog");
                }
            }
            if (summoner)
                summoner.sendMessage("§7Successfully set today as a Herobrine Fog day.§r");
        }
    }
    else {
        for (const player of world.getPlayers()) {
            player.runCommand("fog @s pop zpig:herobrine_fog");
            player.runCommand("fog @s pop zpig:heavy_calamity_fog");
        }
    }
}

function increaseAnger(player, amount) {
    player.setDynamicProperty("herobrine_anger", player.getDynamicProperty("herobrine_anger") + amount);
    //world.sendMessage(player.name + "'s Herobrine Anger: " + player.getDynamicProperty("herobrine_anger"));
}

world.afterEvents.playerInteractWithBlock.subscribe((data) => {
    const { player, block } = data;
    const spots = block.dimension.getEntities({
        location: block.location,
        closest: 1,
        maxDistance: 1,
        type: 'zpig:herobrine_spot_entity',
        tags: ["zpig:herobrine_special_sign_spot"],
    });
    if (!player.isSneaking && spots.length > 0) {
        const spot = spots[0];
        const sign = block.getComponent("minecraft:sign");
        const actionForm = new ActionFormData().title("Answer Herobrine's Question?");
        actionForm.body("\"" + sign.getText() + "\"");
        actionForm.button('Yes');
        actionForm.button('No');
        actionForm.button('Close');
        actionForm.show(player).then(response => {
            if (response.selection != undefined && response.selection == 0) {
                if (spot.getProperty("zpig:special_sign_type") == 0) {
                    sign.setText("§oStories cannot always be trusted...");
                }
                else if (spot.getProperty("zpig:special_sign_type") == 1) {
                    sign.setText("§oI will trust you. You must build an altar.");
                }
                else if (spot.getProperty("zpig:special_sign_type") == 2) {
                    sign.setText("§oPlease help me, brother. I know you can.");
                }
                else if (spot.getProperty("zpig:special_sign_type") == 3) {
                    sign.setText("§oGood. Now you must build one yourself.");
                }
                else {
                    sign.setText("§oLet us hope so. You must find the altars.");
                }
                spot.remove();
            }
            else if (response.selection == 1) {
                if (spot.getProperty("zpig:special_sign_type") == 0) {
                    sign.setText("§oThen you understand my plight?");
                }
                else if (spot.getProperty("zpig:special_sign_type") == 1) {
                    sign.setText("§oI pray this isn't true. You find the altars.");
                }
                else if (spot.getProperty("zpig:special_sign_type") == 2) {
                    sign.setText("§o...\nYou are just like him...");
                }
                else if (spot.getProperty("zpig:special_sign_type") == 3) {
                    sign.setText("§oIf you don't, then we are doomed.");
                }
                else {
                    sign.setText("§oThe calamity looms closer each and every day.");
                }
                spot.remove();
            }
        })
    }
});

world.afterEvents.playerPlaceBlock.subscribe(function(data) {
    if (data.block.typeId == "minecraft:torch") {
        const spot = data.block.dimension.spawnEntity("zpig:herobrine_spot_entity<zpig:player_torch>", data.block.location);
        //world.sendMessage("Torch Placed.");
        //data.block.setPermutation(BlockPermutation.resolve("minecraft:dirt"));
    }
    else if (data.block.typeId == "minecraft:standing_sign") {
        const spot = data.block.dimension.spawnEntity("zpig:herobrine_spot_entity<zpig:player_sign>", data.block.location);
        //world.sendMessage("Sign Placed.");
        //world.sendMessage("playerSigns.length: " + playerSigns.length);
        //data.block.setPermutation(BlockPermutation.resolve("minecraft:dirt"));
    }
});

function possessMob(entity) {
    if (entity != undefined) {
        const position = entity.location;
        const dimension = entity.dimension;
        const rotation = entity.getRotation();
        const baby = entity.hasComponent("is_baby");
        let sheared;
        if (entity.typeId == "minecraft:sheep") {
            sheared = entity.hasComponent("is_sheared");
        }
        entity.remove();
        let possessedMob;
        if (entity.typeId == "minecraft:pig") {
            if (baby)
                possessedMob = dimension.spawnEntity("zpig:possessed_pig<zpig:baby>", position);
            else
                possessedMob = dimension.spawnEntity("zpig:possessed_pig<zpig:adult>", position);
        }
        else if (entity.typeId == "minecraft:cow") {
            if (baby)
                possessedMob = dimension.spawnEntity("zpig:possessed_cow<zpig:baby>", position);
            else
                possessedMob = dimension.spawnEntity("zpig:possessed_cow<zpig:adult>", position);
        }
        else if (entity.typeId == "minecraft:chicken") {
            if (baby)
                possessedMob = dimension.spawnEntity("zpig:possessed_chicken<zpig:baby>", position);
            else
                possessedMob = dimension.spawnEntity("zpig:possessed_chicken<zpig:adult>", position);
        }
        else if (entity.typeId == "minecraft:chicken") {
            if (baby)
                possessedMob = dimension.spawnEntity("zpig:possessed_chicken<zpig:baby>", position);
            else
                possessedMob = dimension.spawnEntity("zpig:possessed_chicken<zpig:adult>", position);
        }
        else if (entity.typeId == "minecraft:sheep") {
            if (baby)
                possessedMob = dimension.spawnEntity("zpig:possessed_sheep<zpig:baby>", position);
            else
                possessedMob = dimension.spawnEntity("zpig:possessed_sheep<zpig:adult>", position);
            if (sheared) {
                possessedMob.triggerEvent("zpig:sheared");
            }
        }
        else if (entity.typeId == "minecraft:zombie") {
            if (baby)
                possessedMob = dimension.spawnEntity("zpig:possessed_zombie<zpig:baby>", position);
            else
                possessedMob = dimension.spawnEntity("zpig:possessed_zombie<zpig:adult>", position);
        }
        else if (entity.typeId == "minecraft:skeleton") {
            possessedMob = dimension.spawnEntity("zpig:possessed_skeleton", position);
        }
        possessedMob.setRotation(rotation);
    }
}

world.afterEvents.entitySpawn.subscribe((event) => {
    const { entity, cause } = event;
    if ((cause == "Spawned" || cause == "Born") && herobrineActivity && world.getDay() >= 1) {
        if ((entity.typeId == "minecraft:pig" ||
            entity.typeId == "minecraft:cow" ||
            entity.typeId == "minecraft:chicken" ||
            entity.typeId == "minecraft:sheep" ||
            entity.typeId == "minecraft:zombie" ||
            entity.typeId == "minecraft:skeleton"
        ) && (((((herobrinePossessedMobRate / 20) * (herobrineActivityRate / 10)) * (herobrinePossessedMobRate / 2)) / 50) >= Math.random())) {
            possessMob(entity);
            //world.sendMessage("Possessed " + entity.typeId + " spawned.");
        }
    }
});

system.afterEvents.scriptEventReceive.subscribe((data) => {
    if (data.id == "zpig:toggle_herobrine") {
        if (herobrineActivity) {
            herobrineActivity = false;
            world.setDynamicProperty("herobrine_activity", herobrineActivity);
            world.sendMessage("Herobrine activity has been disabled.");
        }
        else {
            herobrineActivity = true;
            world.setDynamicProperty("herobrine_activity", herobrineActivity);
            world.sendMessage("Herobrine activity has been enabled.");
        }
    }
    else if (data.id == "zpig:remove_torch") {
        deleteTorch(1, data.sourceEntity);
    }
    else if (data.id == "zpig:turn_off_herobrine_activity") {
        world.setDynamicProperty("herobrine_defeated", true);
        world.setDynamicProperty("herobrine_activity", false);
        herobrineActivity = false;
        //world.sendMessage("Herobrine activity has been disabled.");
    }
    else if (data.id == "zpig:summon_disc") {
        const players = data.sourceEntity.dimension.getEntities({
            location: data.sourceEntity.location,
            closest: 1,
            type: 'minecraft:player',
            excludeGameModes: ['spectator'],
        });
        if (players.length > 0) {
            const player = players[0];
            data.sourceEntity.dimension.spawnItem((new ItemStack("zpig:music_disc_two_pixels", 1)), player.location);
            if (calamityEnabled) {
                const actionForm = new ActionFormData().title("You defeated Herobrine");
                actionForm.body("\nYou defeated Herobrine, but the Calamity is still coming.\n\nThe Music Disc is the key to stopping the Calamity.\n\n\n\n\n\n\n\n");
                actionForm.button("Close");
                actionForm.show(player);
            }
        }
        else {
            data.sourceEntity.dimension.spawnItem((new ItemStack("zpig:music_disc_two_pixels", 1)), data.sourceEntity.location);
        }
    }
    else if (data.id == "zpig:calamity_defeated") {
        const players = data.sourceEntity.dimension.getEntities({
            location: data.sourceEntity.location,
            maxDistance: 28,
            type: 'minecraft:player',
            excludeGameModes: ['spectator'],
        });
        world.setDynamicProperty("calamity_enabled", false);
        calamityEnabled = false;
        if (players.length > 0) {
            for (const player of players) {
                const actionForm = new ActionFormData().title("You stopped the Calamity");
                actionForm.body("\nYou have defeated White Eyes and have stopped the Calamity!\nCongratulations!\n\nCalamity activity has been disabled. You can reenable from the Herobrine menu, opened using /function zpig.herobrine_menu\n\n\n\n\n");
                actionForm.button("Close");
                actionForm.show(player);
            }
        }
    }
    else if (data.id == "zpig:open_herobrine_menu") {
        const players = data.sourceEntity.dimension.getEntities({
            location: data.sourceEntity.location,
            closest: 1,
            type: 'minecraft:player',
            excludeGameModes: ['spectator'],
        });
        openHerobrineMenu(players[0]);
    }
    else if (data.id == "zpig:summon_herobrine_for_nightmare") {
        const players = data.sourceEntity.dimension.getEntities({
            location: data.sourceEntity.location,
            closest: 1,
            type: 'minecraft:player',
            excludeGameModes: ['spectator'],
        });
        const herobrine = data.sourceEntity.dimension.spawnEntity("zpig:herobrine<zpig:mode_3>", { x: data.sourceEntity.location.x, y: data.sourceEntity.location.y, z: data.sourceEntity.location.z });
        facePlayer(players[0], herobrine);
        players[0].runCommand("playsound ambient.cave @s");
    }
    else if (data.id == "zpig:offset_black_hole") {
        data.sourceEntity.runCommand(`execute as @s align xyz run tp @s ~0.5 ~${(data.sourceEntity.getProperty("zpig:size") / 1.25)} ~0.5 true`);
    }
    /*else if (data.id == "zpig:nightmare_rate") {
        if (isNaN(parseFloat(data.message))) {
            if ((((0.05 + ((herobrineNightmareRate - 1) / 10)) + (herobrineActivityRate / 20)) * 100) >= 100) {
                world.sendMessage("Herobrine's Nightmare Rate is 100 percent chance when sleeping.");
            }
            else if ((((0.05 + ((herobrineNightmareRate - 1) / 10)) + (herobrineActivityRate / 20)) * 100) <= 0) {
                world.sendMessage("Herobrine's Nightmare Rate is 0 percent chance when sleeping.");
            }
            else {
                world.sendMessage("Herobrine's Nightmare Rate is " + (((0.05 + ((herobrineNightmareRate - 1) / 10)) + (herobrineActivityRate / 20)) * 100).toFixed(2) + " percent chance when sleeping.");
            }
        }
        else {
            herobrineNightmareRate = parseFloat(data.message);
            for (const player of world.getPlayers()) {
                player.setDynamicProperty("herobrine_nightmare_rate", herobrineNightmareRate);
            }
            if ((((0.05 + ((herobrineNightmareRate - 1) / 10)) + (herobrineActivityRate / 20)) * 100) >= 100) {
                world.sendMessage("Herobrine's Nightmare Rate changed to 100 percent chance when sleeping.");
            }
            else if ((((0.05 + ((herobrineNightmareRate - 1) / 10)) + (herobrineActivityRate / 20)) * 100) <= 0) {
                world.sendMessage("Herobrine's Nightmare Rate changed to 0 percent chance when sleeping.");
            }
            else {
                world.sendMessage("Herobrine's Nightmare Rate changed to " + (((0.05 + ((herobrineNightmareRate - 1) / 10)) + (herobrineActivityRate / 20)) * 100).toFixed(2) + " percent chance when sleeping.");
            }
        }
    }*/
});

function pickWeightedPlayer(players) {
    const total = players.reduce((sum, player) => sum + player.getDynamicProperty("herobrine_anger"), 0);
    let point = Math.random() * total;
    for (const player of players) {
        point -= player.getDynamicProperty("herobrine_anger");
        if (point < 0) {
            return player;
        }
    }
    return players[players.length - 1];
}

system.runInterval(() => {
    if (herobrineActivity && world.getDay() >= 1 && herobrineActivityRate > 0 && world.getDynamicProperty("herobrine_activity_timer") > 0) {
        world.setDynamicProperty("herobrine_activity_timer", world.getDynamicProperty("herobrine_activity_timer") - 1);
        //world.sendMessage("Herobrine Activity Timer: " + world.getDynamicProperty("herobrine_activity_timer"));
        if (world.getDynamicProperty("herobrine_activity_timer") == 0) {
            runHerobrineFunctions(0);
            world.setDynamicProperty("herobrine_activity_timer", Math.trunc(600 * (Math.random() * (1.2 - 0.8) + 0.8)));
        }
    }
    if (herobrineActivity && world.getDay() >= 1 && herobrineDeleteTorchRate > 0 && world.getDynamicProperty("herobrine_delete_torch_timer") > 0 && playerTorchSpotList.length > 0) {
        world.setDynamicProperty("herobrine_delete_torch_timer", world.getDynamicProperty("herobrine_delete_torch_timer") - 1);
        //world.sendMessage("Herobrine Delete Torch Timer: " + world.getDynamicProperty("herobrine_delete_torch_timer"));
        if (world.getDynamicProperty("herobrine_delete_torch_timer") == 0) {
            deleteTorch(0);
            world.setDynamicProperty("herobrine_delete_torch_timer", Math.trunc((600 * (Math.random() * (1.1 - 0.9) + 0.9)) / (herobrineDeleteTorchRate / 10)));
        }
    }
    if (calamityEnabled && daysUntilCalamity <= 10 && daysUntilCalamity > 0 && world.getDynamicProperty("calamity_shake_timer") > 0) {
        world.setDynamicProperty("calamity_shake_timer", world.getDynamicProperty("calamity_shake_timer") - 1);
        //world.sendMessage("Calamity Shake Timer: " + world.getDynamicProperty("calamity_shake_timer"));
        if (world.getDynamicProperty("calamity_shake_timer") == 0) {
            for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
                player.runCommand("camerashake add @s 0.06 4");
                player.playSound("random.calamity_rumble_short");
            }
            world.setDynamicProperty("calamity_shake_timer", Math.trunc(600 * (Math.random() * (1.25 - 0.75) + 0.75)));
        }
    }
    for (const player of world.getPlayers({excludeGameModes: ['spectator'],})) {
        if (player.getDynamicProperty("herobrine_anger_decay_timer") > 0 && player.getDynamicProperty("herobrine_anger") > 1) {
            player.setDynamicProperty("herobrine_anger_decay_timer", player.getDynamicProperty("herobrine_anger_decay_timer") - 1);
            //world.sendMessage(player.name + "'s Herobrine Anger Decay Timer: " + player.getDynamicProperty("herobrine_anger_decay_timer"));
            if (player.getDynamicProperty("herobrine_anger_decay_timer") == 1) {
                player.setDynamicProperty("herobrine_anger_decay_timer", Math.trunc(900 * (Math.random() * (1.25 - 0.75) + 0.75)));
                player.setDynamicProperty("herobrine_anger", player.getDynamicProperty("herobrine_anger") - 1);
                //world.sendMessage(player.name + "'s Herobrine Anger: " + player.getDynamicProperty("herobrine_anger"));
            }
        }
        if (player.getDynamicProperty("herobrine_timer") > -1) {
            player.setDynamicProperty("herobrine_timer", player.getDynamicProperty("herobrine_timer") - 1);
            //world.sendMessage(player.name + "'s Herobrine Timer: " + player.getDynamicProperty("herobrine_timer"));
            if (player.getDynamicProperty("herobrine_timer") == 0) {
                player.removeTag("zpig:herobrine_timer");
                summonHerobrine(player, 0, 0);
            }
        }
        if (player.getDynamicProperty("herobrine_sign_timer") > -1) {
            player.setDynamicProperty("herobrine_sign_timer", player.getDynamicProperty("herobrine_sign_timer") - 1);
            //world.sendMessage(player.name + "'s Herobrine Sign Timer: " + player.getDynamicProperty("herobrine_sign_timer"));
            if (player.getDynamicProperty("herobrine_sign_timer") == 0) {
                player.removeTag("zpig:herobrine_sign_timer");
                writeMessage(player, 0);
            }
        }
        if (player.getDynamicProperty("herobrine_altar_timer") > -1) {
            player.setDynamicProperty("herobrine_altar_timer", player.getDynamicProperty("herobrine_altar_timer") - 1);
            //world.sendMessage(player.name + "'s Herobrine Altar Timer: " + player.getDynamicProperty("herobrine_altar_timer"));
            if (player.getDynamicProperty("herobrine_altar_timer") == 0) {
                player.removeTag("zpig:herobrine_altar_timer");
                spawnAltar(player, 0);
            }
        }
        if (player.getDynamicProperty("herobrine_ambience_timer") > -1) {
            player.setDynamicProperty("herobrine_ambience_timer", player.getDynamicProperty("herobrine_ambience_timer") - 1);
            //world.sendMessage(player.name + "'s Herobrine Ambience Timer: " + player.getDynamicProperty("herobrine_ambience_timer"));
            if (player.getDynamicProperty("herobrine_ambience_timer") == 0) {
                player.removeTag("zpig:herobrine_ambience_timer");
                playAmbience(player, 0);
            }
        }
        if (player.getDynamicProperty("herobrine_footsteps_timer") > -1 && player.location.y < 62 && !player.isInWater) {
            player.setDynamicProperty("herobrine_footsteps_timer", player.getDynamicProperty("herobrine_footsteps_timer") - 1);
            //world.sendMessage(player.name + "'s Herobrine Footsteps Timer: " + player.getDynamicProperty("herobrine_footsteps_timer"));
            if (player.getDynamicProperty("herobrine_footsteps_timer") == 0) {
                player.removeTag("zpig:herobrine_footsteps_timer");
                walkStone(player, 0);
            }
        }
        if (player.getDynamicProperty("herobrine_torch_deepslate_timer") > -1 && player.location.y < 0) {
            player.setDynamicProperty("herobrine_torch_deepslate_timer", player.getDynamicProperty("herobrine_torch_deepslate_timer") - 1);
            //world.sendMessage(player.name + "'s Herobrine Torch Deepslate Timer: " + player.getDynamicProperty("herobrine_torch_deepslate_timer"));
            if (player.getDynamicProperty("herobrine_torch_deepslate_timer") == 0) {
                player.removeTag("zpig:herobrine_torch_deepslate_timer");
                torchDeepslate(player, 0);
            }
        }
        if (player.getDynamicProperty("remove_day_50_calamity_fog_timer") > -1) {
            player.setDynamicProperty("remove_day_50_calamity_fog_timer", player.getDynamicProperty("remove_day_50_calamity_fog_timer") - 1);
            if (player.getDynamicProperty("remove_day_50_calamity_fog_timer") == 0) {
                player.runCommand("fog @s pop zpig:day_50_calamity_fog");
            }
        }
        if (player.getDynamicProperty("white_eyes_counter_timer") > -1) {
            player.setDynamicProperty("white_eyes_counter_timer", player.getDynamicProperty("white_eyes_counter_timer") - 1);
            if (player.getDynamicProperty("white_eyes_counter_timer") == 0) {
                player.runCommand("inputpermission set @s movement enabled");
                player.applyDamage(12);
                player.runCommand("camera @s fade color 255 255 255");
            }
        }
        if (player.getDynamicProperty("calamity_enemy_summon_timer") > -1) {
            player.setDynamicProperty("calamity_enemy_summon_timer", player.getDynamicProperty("calamity_enemy_summon_timer") - 1);
            //world.sendMessage(player.name + "'s Calamity Enemy Summon Timer: " + player.getDynamicProperty("calamity_enemy_summon_timer"));
            if (player.getDynamicProperty("calamity_enemy_summon_timer") == 0 && world.getDynamicProperty("is_day_of_calamity") && calamityEnabled) {
                const coord = getValidCoordinate(player, 4, 2);
                if (Math.random() >= 0.5)
                    player.dimension.spawnEntity("zpig:void_tentacle", coord);
                else
                    player.dimension.spawnEntity("zpig:void_black_hole", coord);
            }
        }
    }
}, 20);

function choosePlayerForHerobrineActivity(type) {
    if (type == undefined)
        type = 0;
    if (type == 0) {
        const players = world.getPlayers({excludeTags: ['zpig:herobrine_timer'],excludeGameModes: ['spectator'],});
        if (players.length > 0) {
            const player = pickWeightedPlayer(players);
            player.setDynamicProperty("herobrine_timer", Math.trunc(((360000 / herobrineActivityRate) * Math.random()) / 20));
            player.addTag("zpig:herobrine_timer");
        }
    }
    else if (type == 1) {
        const players = world.getPlayers({excludeTags: ['zpig:herobrine_sign_timer'],excludeGameModes: ['spectator'],});
        if (players.length > 0) {
            const player = pickWeightedPlayer(players);
            player.setDynamicProperty("herobrine_sign_timer", Math.trunc(((288000 / (herobrineActivityRate * ((((herobrineSignRate + herobrineSpecialSignRate) - 10) / 20) / 0.5))) * Math.random()) / 20));
            player.addTag("zpig:herobrine_sign_timer");
        }
    }
    else if (type == 2) {
        const players = world.getPlayers({excludeTags: ['zpig:herobrine_altar_timer'],excludeGameModes: ['spectator'],});
        if (players.length > 0) {
            const player = pickWeightedPlayer(players);
            player.setDynamicProperty("herobrine_altar_timer", Math.trunc(((2400000 / (herobrineActivityRate * ((herobrineAltarRate / 20) / 0.5))) * Math.random()) / 20));
            player.addTag("zpig:herobrine_altar_timer");
        }
    }
    else if (type == 3) {
        const players = world.getPlayers({excludeTags: ['zpig:herobrine_ambience_timer'],excludeGameModes: ['spectator'],});
        if (players.length > 0) {
            const player = pickWeightedPlayer(players);
            player.setDynamicProperty("herobrine_ambience_timer", Math.trunc(((192000 / (herobrineActivityRate * ((herobrineAmbienceRate / 20) / 0.5))) * Math.random()) / 20));
            player.addTag("zpig:herobrine_ambience_timer");
        }
    }
    else if (type == 4) {
        const players = world.getPlayers({excludeTags: ['zpig:herobrine_footsteps_timer'],excludeGameModes: ['spectator'],});
        if (players.length > 0) {
            const player = pickWeightedPlayer(players);
            player.setDynamicProperty("herobrine_footsteps_timer", Math.trunc(((192000 / (herobrineActivityRate * ((herobrineFootstepsRate / 20) / 0.5))) * Math.random()) / 20));
            player.addTag("zpig:herobrine_footsteps_timer");
        }
    }
    else if (type == 5) {
        const players = world.getPlayers({excludeTags: ['zpig:herobrine_torch_deepslate_timer'],excludeGameModes: ['spectator'],});
        if (players.length > 0) {
            const player = pickWeightedPlayer(players);
            player.setDynamicProperty("herobrine_torch_deepslate_timer", Math.trunc(((288000 / (herobrineActivityRate * ((herobrineTorchDeepslateRate / 20) / 0.5))) * Math.random()) / 20));
            player.addTag("zpig:herobrine_torch_deepslate_timer");
        }
    }
}

function runHerobrineFunctions() {
    if (herobrineActivity && world.getDay() >= 1) {
        if (herobrineActivityRate > 0 && (herobrineActivityRate / 20) >= Math.random()) {
            choosePlayerForHerobrineActivity(0);
        }
        if (herobrineActivityRate > 0 && ((Math.pow(herobrineActivityRate, 0.585) * ((herobrineSignRate + herobrineSpecialSignRate) - 10)) / 76.91) >= Math.random()) {
            choosePlayerForHerobrineActivity(1);
        }
        if (herobrineAltarRate > 0 && herobrineActivityRate > 0 && ((Math.pow(herobrineActivityRate, 0.585) * herobrineAltarRate) / 76.91) >= Math.random()) {
            choosePlayerForHerobrineActivity(2);
        }
        if (herobrineAmbienceRate > 0 && herobrineActivityRate > 0 && ((Math.pow(herobrineActivityRate, 0.585) * herobrineAmbienceRate) / 76.91) >= Math.random()) {
            choosePlayerForHerobrineActivity(3);
        }
        if (herobrineFootstepsRate > 0 && herobrineActivityRate > 0 && ((Math.pow(herobrineActivityRate, 0.585) * herobrineFootstepsRate) / 76.91) >= Math.random()) {
            choosePlayerForHerobrineActivity(4);
        }
        if (herobrineTorchDeepslateRate > 0 && herobrineActivityRate > 0 && ((Math.pow(herobrineActivityRate, 0.585) * herobrineTorchDeepslateRate) / 76.91) >= Math.random()) {
            choosePlayerForHerobrineActivity(5);
        }
    }
}

function voidBlackHoleLogic() {
    const allBlackHolesOverworld = world.getDimension("overworld").getEntities({type: 'zpig:void_black_hole',});
    const allBlackHolesNether = world.getDimension("nether").getEntities({type: 'zpig:void_black_hole',});
    const allBlackHolesEnd = world.getDimension("the_end").getEntities({type: 'zpig:void_black_hole',});
    const allBlackHoles = allBlackHolesOverworld.concat(allBlackHolesNether, allBlackHolesEnd);
    allBlackHoles.forEach((blackHole) => {
        const size = blackHole.getProperty("zpig:size");
        const eventHorizon = size * 0.5;
        const maxDistance = size * 6;
        const players = blackHole.dimension.getEntities({
            location: blackHole.location,
            maxDistance: maxDistance,
            type: 'minecraft:player',
            excludeGameModes: ['creative', 'spectator'],
        });
        players.forEach((player) => {
            const dx = player.location.x - blackHole.location.x;
            const dy = (player.location.y + 1) - blackHole.location.y;
            const dz = player.location.z - blackHole.location.z;
            const distance = Math.sqrt(dx * dx + dy * dy + dz * dz);
            if (distance < (eventHorizon * 0.2)) {
                player.applyDamage(size, {cause: "void",});
                blackHole.triggerEvent("zpig:despawn");
            }
            else {
                const range = maxDistance - eventHorizon;
                if (range <= 0) return;
                const normalized = (distance - eventHorizon) / range;
                let pullFactor = 1 - normalized * normalized;
                pullFactor = Math.max(pullFactor, 0);
                const baseStrength = 0.15 * size;
                const scaledStrength = baseStrength * (8 / maxDistance);
                const strength = pullFactor * scaledStrength;
                const dirX = dx / distance;
                const dirY = dy / distance;
                const dirZ = dz / distance;
                //world.sendMessage("eventHorizon: " + eventHorizon);
                //world.sendMessage("distance: " + distance);
                //world.sendMessage("strength: " + strength);
                player.applyKnockback(-dirX, -dirZ, strength, -dirY * strength);
            }
        });
    });
}

function whiteEyesCalamityLogic() {
    if (whiteEyesCalamityList.length > 1) {
        whiteEyesCalamityList.slice(1).forEach((whiteEyes) => {
            whiteEyes.remove();
        });
    }
    if (calamitySpawnerList.length > 1) {
        calamitySpawnerList.slice(1).forEach((calamitySpawner) => {
            calamitySpawner.remove();
        });
    }
    if (daysUntilCalamity > 0) {
        whiteEyesCalamityList.forEach((whiteEyes) => {
            whiteEyes.runCommand("stopsound @a mob.white_eyes_calamity.loop");
            whiteEyes.remove();
        });
    }
    if (daysUntilCalamity > 0) {
        calamitySpawnerList.forEach((calamitySpawner) => {
            calamitySpawner.remove();
        });
    }
    const calamityList = whiteEyesCalamityList.concat(calamitySpawnerList);
    calamityList.forEach((whiteEyes) => {
        if (whiteEyes != undefined) {
            const closestTargetSurvivalList = whiteEyes.dimension.getPlayers({
                location: whiteEyes.location,
                closest: 1,
                excludeGameModes: ['creative', 'spectator'],
            });
            const survivalPlayers = whiteEyes.dimension.getPlayers({
                excludeGameModes: ['creative', 'spectator'],
            });
            const closestTargetCreativeList = whiteEyes.dimension.getPlayers({
                location: whiteEyes.location,
                closest: 1,
                excludeGameModes: ['spectator'],
            });
            const creativePlayers = whiteEyes.dimension.getPlayers({
                excludeGameModes: ['spectator'],
            });
            let closestTargetSurvival = null;
            let closestTargetCreative = null;
            if (closestTargetSurvivalList.length > 0)
                closestTargetSurvival = closestTargetSurvivalList[0];
            if (closestTargetCreativeList.length > 0)
                closestTargetCreative = closestTargetCreativeList[0];
            if (closestTargetSurvival != null) {
                if (!closestTargetSurvival.hasTag("zpig:calamity_target"))
                    closestTargetSurvival.addTag("zpig:calamity_target");
            }
            else if (closestTargetCreative != null) {
                if (!closestTargetCreative.hasTag("zpig:calamity_target"))
                    closestTargetCreative.addTag("zpig:calamity_target");
            }
            for (const player of world.getPlayers()) {
                if (player.hasTag("zpig:calamity_target") && closestTargetSurvival != null && player.id != closestTargetSurvival.id) {
                    player.removeTag("zpig:calamity_target");
                }
                else if (player.hasTag("zpig:calamity_target") && closestTargetSurvival != null && player.id != closestTargetCreative.id) {
                    player.removeTag("zpig:calamity_target");
                }
                else if (player.hasTag("zpig:calamity_target") && closestTargetCreative != null && player.id != closestTargetCreative.id) {
                    player.removeTag("zpig:calamity_target");
                }
            }
            let target;
            if (closestTargetSurvival != null) {
                target = closestTargetSurvival;
            }
            else if (closestTargetCreative != null) {
                target = closestTargetCreative;
            }
            facePlayer(target, whiteEyes);
            whiteEyesCalamityFollowPlayer(target, whiteEyes, 48, 32);
        }
    });
}

function whiteEyesCalamityFollowPlayer(player, whiteEyes, maxDistance, minDistance) {
    const whiteEyesLocation = whiteEyes.location;
    let dx = player.location.x - whiteEyes.location.x;
    let dy = player.location.y - whiteEyes.location.y;
    let dz = player.location.z - whiteEyes.location.z;
    if (dx == 0)
        dx = Math.random() * 2 - 1;
    if (dy == 0)
        dy = Math.random();
    if (dz == 0)
        dz = Math.random() * 2 - 1;
    const distance = Math.sqrt(dx * dx + dz * dz);
    const distanceY = Math.sqrt(dy * dy);
    const dirX = dx / distance;
    const dirZ = dz / distance;
    const topBlock = whiteEyes.dimension.getTopmostBlock({ x: whiteEyes.location.x, z: whiteEyes.location.z });
    const topBlockNorth = whiteEyes.dimension.getTopmostBlock({ x: whiteEyes.location.x, z: (whiteEyes.location.z - 8) });
    const topBlockSouth = whiteEyes.dimension.getTopmostBlock({ x: whiteEyes.location.x, z: (whiteEyes.location.z + 8) });
    const topBlockEast = whiteEyes.dimension.getTopmostBlock({ x: (whiteEyes.location.x + 8), z: whiteEyes.location.z });
    const topBlockWest = whiteEyes.dimension.getTopmostBlock({ x: (whiteEyes.location.x + 8), z: whiteEyes.location.z });
    const blockLocations = [topBlock.location.y, topBlockNorth.location.y, topBlockSouth.location.y, topBlockEast.location.y, topBlockWest.location.y,];
    const height = Math.max(...blockLocations);
    //world.sendMessage("height: " + height);
    //world.sendMessage("distance: " + distance);
    if (whiteEyes.typeId == "zpig:calamity_spawner_entity") {
        system.runTimeout(() => {
            if (whiteEyes != undefined) {
                whiteEyes.teleport({x: whiteEyesLocation.x, y: 315, z: whiteEyesLocation.z});
                system.runTimeout(() => {
                    const whiteEyesLocationNew = whiteEyes.location;
                    world.structureManager.place("zpig.[REDACTED]_calamity", world.getDimension("overworld"), whiteEyesLocationNew);
                    whiteEyes.remove();
                }, 10);
            }
        }, 40);
    }
    if (distance > 1000) {
        whiteEyes.teleport({x: (player.location.x * (Math.random() * 200 - 100)), y: 330, z: (player.location.z * (Math.random() * 200 - 100))});
    }
    if (whiteEyes.location.y < height + 6) {
        //world.sendMessage("Too close to block");
        whiteEyes.applyKnockback(whiteEyes.location.x, whiteEyes.location.z, 0, 0.05 * (distance / 32));
    }
    else if (distance > maxDistance && (whiteEyes.location.y >= height || whiteEyes.location.y < height)) {
        whiteEyes.applyKnockback(dirX, dirZ, 1 * (distance / 32), 0);
    }
    else if (distance < minDistance && whiteEyes.location.y >= height) {
        whiteEyes.applyKnockback(-dirX, -dirZ, 1, 0);
    }
    if (whiteEyes.location.y < height + 6) {
        //world.sendMessage("Too close to block");
        whiteEyes.applyKnockback(whiteEyes.location.x, whiteEyes.location.z, 0, 0.05 * (distance / 32));
    }
    if (distanceY > maxDistance && (whiteEyes.location.y >= height + 6 || whiteEyes.location.y < height)) {
        //world.sendMessage("Too far from player");
        if (player.location.y <= whiteEyes.location.y) {
            whiteEyes.applyKnockback(whiteEyes.location.x, whiteEyes.location.z, 0, -0.05 * (distance / 32) * (distanceY / 32));
        }
        else {
            whiteEyes.applyKnockback(whiteEyes.location.x, whiteEyes.location.z, 0, 0.05 * (distance / 32) * (distanceY / 32));
        }
    }
    else if (distanceY < minDistance) {
        //world.sendMessage("Too close to player");
        whiteEyes.applyKnockback(whiteEyes.location.x, whiteEyes.location.z, 0, 0.05);
    }
}

function calamitySpawnerLogic(calamitySpawner, player) {
    system.runTimeout(() => {
        if (calamitySpawner != undefined && calamitySpawner != null && whiteEyesCalamityList.length <= 0 && calamitySpawnerList.length <= 1) {
            calamitySpawner.teleport({x: (player.location.x + (Math.random() * 1500 - 750)), y: 320, z: (player.location.z + (Math.random() * 1500 - 750))});
            calamitySpawner.triggerEvent("zpig:transform");
        }
        else if (calamitySpawner != undefined) {
            calamitySpawner.triggerEvent("zpig:despawn");
        }
    }, 10);
}

function whiteEyesLogic() {
    if (whiteEyesCalamityList.length > 0 && whiteEyesList.length > 0) {
        whiteEyesList.forEach((whiteEyes) => {
            whiteEyes.remove();
        });
    }
    if (whiteEyesList.length > 1) {
        whiteEyesList.slice(1).forEach((whiteEyes) => {
            whiteEyes.remove();
        });
    }
    whiteEyesList.forEach((whiteEyes) => {
        if (whiteEyes.getComponent("skin_id") && whiteEyes.getComponent("skin_id").value == 1 && !whiteEyes.getProperty("zpig:music_started")) {
            whiteEyes.setProperty("zpig:music_started", true);
            const nearbyPlayers = whiteEyes.dimension.getEntities({
                location: whiteEyes.location,
                maxDistance: 28,
                type: 'minecraft:player',
                excludeGameModes: ['spectator'],
            });
            const nearbyPlayersSpectator = whiteEyes.dimension.getEntities({
                location: whiteEyes.location,
                maxDistance: 28,
                type: 'minecraft:player',
            });
            system.runTimeout(() => {
                for (const player of nearbyPlayers) {
                    player.runCommand("title @s title zpig.display_calamity_eyes");
                }
            }, 240);
            system.runTimeout(() => {
                for (const player of nearbyPlayersSpectator) {
                    player.runCommand("title @s title zpig.remove_calamity_eyes");
                }
            }, 250);
            system.runTimeout(() => {
                for (const player of nearbyPlayers) {
                    player.runCommand("title @s title zpig.display_calamity_eyes");
                }
            }, 300);
            system.runTimeout(() => {
                for (const player of nearbyPlayersSpectator) {
                    player.runCommand("title @s title zpig.remove_calamity_eyes");
                }
            }, 310);
            system.runTimeout(() => {
                for (const player of nearbyPlayers) {
                    player.runCommand("title @s title zpig.display_calamity_eyes");
                }
            }, 358);
            system.runTimeout(() => {
                for (const player of nearbyPlayersSpectator) {
                    player.runCommand("title @s title zpig.remove_calamity_eyes");
                }
            }, 368);
            system.runTimeout(() => {
                for (const player of nearbyPlayers) {
                    player.runCommand("title @s title zpig.display_calamity_eyes");
                    //player.playSound("mob.white_eyes.teleport", { pitch: (Math.random() * (1.2 - 0.8) + 0.8) });
                }
            }, 515);
            system.runTimeout(() => {
                for (const player of nearbyPlayersSpectator) {
                    player.runCommand("title @s title zpig.remove_calamity_eyes");
                }
            }, 525);
        }
        if (whiteEyes.getComponent("skin_id") && whiteEyes.getComponent("skin_id").value == 3 && !whiteEyes.getProperty("zpig:music_ended")) {
            whiteEyes.setProperty("zpig:music_ended", true);
            for (const player of world.getPlayers()) {
                player.runCommand("stopsound @s music.white_eyes");
                player.runCommand("stopsound @s music.white_eyes_intro");
            }
        }
    });
}

world.afterEvents.playerInteractWithBlock.subscribe((eventData) => {
    const { player, block, itemStack } = eventData;
    if (block.typeId == "minecraft:jukebox" && block.dimension.id == "minecraft:overworld" && whiteEyesList.length <= 0 && !world.getDynamicProperty("is_day_of_calamity") && itemStack != undefined && itemStack.typeId == "zpig:music_disc_two_pixels") {
        if (calamityEnabled) {
            if (player.getGameMode() == "survival" || player.getGameMode() == "adventure") {
                const mainhand = player.getComponent("minecraft:equippable").getEquipmentSlot(EquipmentSlot.Mainhand);
                mainhand.setItem(undefined);
            }
            player.runCommand("title @s actionbar Now Playing: §7§kFurnace§r§7 - TWO PIXELS§r");
            //block.dimension.spawnEntity("zpig:white_eyes", block.location);
            world.structureManager.place("zpig.[REDACTED]", block.dimension, block.location);
        }
        else {
            player.sendMessage("§7The Calamity must be enabled in order to play this Music Disc.§r");
        }
    }
});

//system.runInterval(choosePlayerToSummonHerobrine, (3600 / Math.sqrt(herobrineActivityRate)));

//system.runInterval(choosePlayerToPlayHerobrineFootsteps, (3000 / Math.sqrt(herobrineActivityRate)));

//system.runInterval(choosePlayerToPlayHerobrineAmbience, (2400 / Math.sqrt(herobrineActivityRate)));

/*system.runInterval(() => {
    deleteTorch(0);
}, (9600 / Math.sqrt(herobrineActivityRate)));*/

//system.runInterval(choosePlayerToPlaceHerobrineSign, (12000 / Math.sqrt(herobrineActivityRate)));

//system.runInterval(choosePlayerToPlaceHerobrineAltar, (42000 / Math.sqrt(herobrineActivityRate)));

system.runInterval(voidBlackHoleLogic, 1);

system.runInterval(whiteEyesLogic, 1);

system.runInterval(whiteEyesCalamityLogic, 1);

system.runInterval(updateHerobrineSpotList, 1);

system.runInterval(updateHerobrineList, 1);

system.runInterval(updateWhiteEyesList, 1);

//runHerobrineFunctions();